/***************************************************************************
 *   Copyright (C) 2004 by EVER Sp. z o.o.                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ps_drv_sinlinexl.h"

/* 
 * IMPLEMENTACJA
 */

// Function name	: ioctl
// Description		: Control function
// Return type		: int 
// Argument       : long lCommand
// Argument       : void *lpvBuff
// Argument       : int *lpiBuffSize
int sinlinexl_ioctl(long lCommand, void *lpvBuff, int *lpiBuffSize)
{
	switch(lCommand)
	{
	case IOCTL_INIT: 
		return DoInit(lpvBuff, lpiBuffSize);

	case IOCTL_UNINIT: 
		return DoUnInit(lpvBuff, lpiBuffSize);

	case IOCTL_AUTOCONFIGURE: 
		return DoAutoConfigure(lpvBuff, lpiBuffSize);

	case IOCTL_CONFIGURE: 
		return DoConfigure(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSINFOMASK: 
		return DoGetUpsInfoMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSINFOMASK:
		return DoSetUpsInfoMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSTATESMASK:
		return DoGetUpsStateMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSTATESMASK:
		return DoSetUpsStateMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSTATE:
		return DoGetUpsState(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSPARAMSMASK:
		return DoGetUpsParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSPARAMSMASK:
		return DoSetUpsParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSPARAMS:
		return DoGetUpsParams(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSETUPPARAMSMASK:
		return DoGetUpsSetupParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSETUPPARAMSMASK:
		return DoSetUpsSetupParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSETUPPARAMS:
		return DoGetUpsSetupParams(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSETUPPARAMS:
		return DoSetUpsSetupParams(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSCHARCTERISTICMASK:
		return DoGetUpsCharacteristicMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSCHARCTERISTIC:
		return DoGetUpsCharacteristic(lpvBuff, lpiBuffSize);

	case IOCTL_GET_DRIVER_INFO:
		return DoGetDriverInfo(lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_INFORMATIONS:
		return DoGetUPSStructures(EU_INFORMATIONS, lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_SETUP:
		return DoGetUPSStructures(EU_SETUP, lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_SPECIAL:
		return DoGetUPSStructures(EU_SPECIAL, lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_HARDWARE:
		return DoGetUPSStructures(EU_HARDWARE, lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_CHARACTERISTICS:
		return DoGetUPSStructures(EU_CHARACTERISTIC, lpvBuff, lpiBuffSize);

	case IOCTL_GET_ERRORNO:
		return DoGetExtendedError(lpvBuff, lpiBuffSize);

	case IOCTL_TESTUPSLINK:
		return DoTestUpsLink(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAMSCOUNT:
		return DoGetConfigParamsCount(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAMS:
		return DoGetConfigParams(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAM:
		return DoGetConfigParam(lpvBuff, lpiBuffSize);

	case IOCTL_SETCONFIGPARAMS:
		return DoSetConfigParams(lpvBuff, lpiBuffSize);

	case IOCTL_SETCONFIGPARAM:
		return DoSetConfigParam(lpvBuff, lpiBuffSize);

	case IOCTL_UPDATECONFIG:
		return DoUpdateConfig(lpvBuff, lpiBuffSize);

	case IOCTL_GETDRIVERMODE:
		return DoGetDriverMode(lpvBuff, lpiBuffSize);

	case IOCTL_SHUTDOWNUPS:
		return DoUpsShutdown(lpvBuff, lpiBuffSize);

	default:
		return IOCTL_ERROR_CMD_NOTSUPPORTED;
	}
}

// Function name	: DoInit
// Description		: Inicjalizacja drivera
// Return type		: int 
// Argument       : void *lpvBuff
// Argument       : int *lpiBuffSize
int DoInit( void *lpvBuff, int *lpiBuffSize )
{
	char	szDrvCfgPath[MAX_PATHBUFF];
	unsigned long	ulSize;
	int	iSize;
/*
	CWinUtil cUtil;

	iExtError = IOCTL_ERROR;
	if ( cUtil.GetStartupDir( szDrvCfgPath, sizeof(szDrvCfgPath) ) < 0 )
		return IOCTL_ERROR;
	strcat( szDrvCfgPath, DRIVER_CONFIG_FILE );

	if ( !cUtil.FileExists( szDrvCfgPath ) )
		return IOCTL_ERROR_NOTYETCONFIGURED;
	ulSize = sizeof( sdcSinlinexl );
	if ( !cUtil.ReadFile( szDrvCfgPath, &sdcSinlinexl, 0, ulSize ) )
		return IOCTL_ERROR_CONFIG_READFAIL;
*/

	if (!ccSinlinexl.Configuration(&dcbSinlinexl, &ctmSinlinexl, &sdcSinlinexl.iSerialPort, TRUE))
	{
		iExtError = IOCTL_ERROR_COMM_CONFIGFAIL;
		return IOCTL_ERROR;
	}
	if (ccSinlinexl.Initialize() <= 0)
	{
		iExtError = IOCTL_ERROR_COMM_INITFAIL;
		return IOCTL_ERROR;
	}

	iExtError = IOCTL_ERROR_COMM_READTABLES;
	iSize = UPS_INF_COUNT;
	if (DoGetUPSStructures(EU_INFORMATIONS, &sdcSinlinexl.iInfTable, &iSize) != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SETUP_COUNT;
	if (DoGetUPSStructures(EU_SETUP, &sdcSinlinexl.iSetupTable, &iSize) != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SPECIAL_COUNT;
	if (DoGetUPSStructures(EU_SPECIAL, &sdcSinlinexl.iSpecialTable , &iSize) != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SPRZET_COUNT;
	if (DoGetUPSStructures(EU_HARDWARE, &sdcSinlinexl.iHardwareTable , &iSize) != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_CHARAKTER_COUNT;
	if (DoGetUPSStructures(EU_CHARACTERISTIC, &sdcSinlinexl.iCharacterTable , &iSize) != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iExtError = 0;

	sdcSinlinexl.bDrvActive = TRUE;
	if ( !cUtil.WriteFile( szDrvCfgPath, ( void * )&sdcSinlinexl, 0, ulSize ) )
	{
		iExtError = IOCTL_ERROR_CONFIG_WRITEFAIL;
		return IOCTL_ERROR;
	}

	iExtError = 0;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoUnInit
// Description		: Deinicjalizacja drivera
// Return type		: int 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int DoUnInit( void *lpvBuff, int *lpiBuffSize )
{
	if ( !ccSinlinexl.UnInitialize() )
		return IOCTL_ERROR;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoAutoConfigure
// Description		: Self configure
// Return type		: int 
// Argument         :  void *lpvBuff
// Argument         : int *lpiBuffSize
int DoAutoConfigure( void *lpvBuff, int *lpiBuffSize )
{
	char szDrvCfgPath[MAX_PATHBUFF];
	unsigned long ulSize;
	CWinUtil cUtils;

	if ( GetStartupDir( szDrvCfgPath ) < 0 )
		return IOCTL_ERROR_CONFIGURATIONFAIL;
	strcat( szDrvCfgPath, DRIVER_CONFIG_FILE );

	ulSize = sizeof( sdcSinlinexl );
	sdcSinlinexl.ulSize = ulSize;
	sdcSinlinexl.iSerialPort = 1;
	if ( sdcSinlinexl.uiBattCapToLB == 0 )
		sdcSinlinexl.uiBattCapToLB = 10;	// 10% to Low Battery signal
	sprintf( sdcSinlinexl.szSerialPort, "COM%d", sdcSinlinexl.iSerialPort );
	
	if ( !cUtils.WriteFile( szDrvCfgPath, ( void * )&sdcSinlinexl, 0, ulSize ) )
		return IOCTL_ERROR_CONFIGURATIONFAIL;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoConfigure
// Description		: Configure driver to work properly with UPS
// Return type		: int 
// Argument         :  void *lpvBuff
// Argument         : int *lpiBuffSize
int DoConfigure( void *lpvBuff, int *lpiBuffSize )
{
	char szDrvCfgPath[MAX_PATHBUFF];
	unsigned long ulSize;
	int	iRet;
	CWinUtil cUtils;

	iRet = DialogBoxParam(
		hModuleInst, (LPCTSTR)IDD_DLGCONFIG, NULL, (DLGPROC)DlgProc_Config, sdcSinlinexl.iSerialPort);
	if (iRet > 0)
	{
		if ( GetStartupDir( szDrvCfgPath ) < 0 )
			return IOCTL_ERROR_CONFIGURATIONFAIL;
		strcat( szDrvCfgPath, DRIVER_CONFIG_FILE );

		ulSize = sizeof( sdcSinlinexl );
		sdcSinlinexl.ulSize = ulSize;
		sdcSinlinexl.iSerialPort = iRet;
		sdcSinlinexl.uiBattCapToLB = 10;
		if ( sdcSinlinexl.uiBattCapToLB == 0 )
			sdcSinlinexl.uiBattCapToLB = 10;
		sprintf( sdcSinlinexl.szSerialPort, "COM%d", sdcSinlinexl.iSerialPort );
		
		if ( !cUtils.WriteFile( szDrvCfgPath, ( void * )&sdcSinlinexl, 0, ulSize ) )
			return IOCTL_ERROR_CONFIGURATIONFAIL;
		else
		{
			DoUnInit(NULL, NULL);
			DoInit(NULL, NULL);
		}
	}
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetUpsInfoMask
// Description		: Zwraca informacje o wypelnieniu struktury informacji o UPS-ie
// Return type		: int 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int DoGetUpsInfoMask( void *lpvBuff, int *lpiBuffSize )
{
	unsigned long	ulMask = 
		UI_CHARACTERISTICS | UI_PARAMETERS | UI_SETUP_PARAMETERS | UI_UPS_STATE;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUpsInfoMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetUpsInfoMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: DoGetUpsStateMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsStateMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long	ulMask = US_POWERON | US_POWERFAIL | US_STANDBY | US_OVERLOAD | US_AVRUP |
		US_AVRLOWER | US_BATTERYDEPLETED | US_WATCH | US_SHORT | US_INTERNALERROR | US_BATTERYLOW |
		US_INVERTERFAILURE | US_TEMPERATURETOOHIGH | US_TEMPERATURETOOLOW | US_BADEXTERNALMODULES;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUpsStateMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetUpsStateMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: DoGetUpsState
// Description		: Return actual UPS state
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsState(void *lpvBuff, int *lpiBuffSize)
{
#undef CONVERT_BIT
#define CONVERT_BIT(src, sbit, dest, dbit) { if (src & sbit) dest |= dbit; else dest &= ~(dbit); }

	unsigned int	*lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	int				iSize = UPS_INF_COUNT;
	unsigned long	ulUpsState = 0;
	int				iRet;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof(ulUpsState))
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		return iRet;
	}

	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0001, ulUpsState, US_BADEXTERNALMODULES );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0002, ulUpsState, US_TEMPERATURETOOLOW );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0004, ulUpsState, US_TEMPERATURETOOHIGH );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0008, ulUpsState, US_INVERTERFAILURE );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0010, ulUpsState, US_INTERNALERROR );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0020, ulUpsState, 0x0 );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0040, ulUpsState, 0x0 );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0080, ulUpsState, US_SHORT );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0100, ulUpsState, US_OVERLOAD );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0200, ulUpsState, US_BATTERYDEPLETED );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0400, ulUpsState, US_WATCH );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0800, ulUpsState, US_AVRLOWER );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x1000, ulUpsState, US_AVRUP );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x2000, ulUpsState, US_STANDBY );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x4000, ulUpsState, US_POWERFAIL );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x8000, ulUpsState, US_POWERON );

	/* Low battery signal is set if battery cap. is below or equal to value set by user
	 at configuration time, and by default is set to 10% */
	if ( ( lpuiInfoTable[ POJ_AKU ] <= sdcSinlinexl.uiBattCapToLB ) && 
		 ( ( ulUpsState & US_POWERFAIL ) == US_POWERFAIL ) )
	{
		ulUpsState |= US_BATTERYLOW;
	}
	else
	{
		ulUpsState &= ~( US_BATTERYLOW );
	}

/*	Low battery signal set if autonomy time is below or equal to 3 minutes.

	if ( ( lpuiInfoTable[ CZAS_PRACY ] <= 3 ) && ( ulUpsState & US_POWERFAIL ) )
		ulUpsState |= US_BATTERYLOW;
	else
		ulUpsState &= ~( US_BATTERYLOW );
*/

	memcpy( lpvBuff, &ulUpsState, *lpiBuffSize );

	delete [] lpuiInfoTable;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetUpsParamsMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulMask = UP_PST_UPPER | UP_PST_LOWER | UP_PST_AVRUP | UP_PST_AVRLOW |
		UP_FRQ_INPUT | UP_FRQ_OUTPUT | UP_VLT_INPUT	| UP_VLT_OUTPUT | UP_VLT_BATTERY | 
		UP_PRC_BATTERYCAPACITY | UP_PRC_POWERWEIGHT | /*UP_SNS_VOLTAGE | UP_SNS_FREQUENCY | */
		UP_TMV_AUTONOMY | /*UP_TMV_ONBATTERY | */UP_TMP_INVERTER | UP_TMP_CASING | 
		UP_UID_FAMILY | UP_UID_MODEL | /*UP_LOAD_OUTPUT | */UP_OV_EXTMODULES;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
		//*(unsigned long *)lpvBuff = ulMask;
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUpsParamsMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetUpsParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: DoGetUpsParams
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int	*lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	unsigned int	*lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	unsigned int	*lpuiCharTable = new unsigned int[UPS_CHARAKTER_COUNT];
	unsigned int	*lpuiSpecialTable = new unsigned int[UPS_SPECIAL_COUNT];
	int				iSize, iRet, i, iv[5];
	supsp			sup;
	char			szUpsName[UPS_MAX_MODELS][64] = { 
		UPS_MODEL700, UPS_MODEL1000, UPS_MODEL1500, UPS_MODEL2000, UPS_MODEL2500, UPS_MODEL3000 };

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( supsp ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	iSize = UPS_INF_COUNT;
	iRet = DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		delete [] lpuiSetupTable;
		delete [] lpuiCharTable;
		delete [] lpuiSpecialTable;
		return iRet;
	}
	iSize = UPS_SETUP_COUNT;
	iRet = DoGetUPSStructures(EU_SETUP, lpuiSetupTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		delete [] lpuiSetupTable;
		delete [] lpuiCharTable;
		delete [] lpuiSpecialTable;
		return iRet;
	}
	iSize = UPS_CHARAKTER_COUNT;
	iRet = DoGetUPSStructures(EU_CHARACTERISTIC, lpuiCharTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		delete [] lpuiSetupTable;
		delete [] lpuiCharTable;
		delete [] lpuiSpecialTable;
		return iRet;
	}
	iSize = UPS_SPECIAL_COUNT;
	iRet = DoGetUPSStructures(EU_SPECIAL, lpuiSpecialTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		delete [] lpuiSetupTable;
		delete [] lpuiCharTable;
		delete [] lpuiSpecialTable;
		return iRet;
	}
	
	sup.ulMask = UP_PST_UPPER | UP_PST_LOWER | UP_PST_AVRUP	| UP_PST_AVRLOW |
		UP_FRQ_INPUT | UP_FRQ_OUTPUT | UP_VLT_INPUT	| UP_VLT_OUTPUT | 
		UP_VLT_BATTERY | UP_PRC_BATTERYCAPACITY | UP_PRC_POWERWEIGHT | 
		/*UP_SNS_VOLTAGE | UP_SNS_FREQUENCY | */UP_TMV_AUTONOMY | /*UP_TMV_ONBATTERY | */
		UP_TMP_INVERTER | UP_TMP_CASING | UP_UID_FAMILY | UP_UID_VERSION | UP_UID_MODEL | 
		/*UP_LOAD_OUTPUT | */UP_OV_EXTMODULES;
	/* bits (8-11) = ups model number; bits (12-15) = ups family */
	i = ( lpuiSpecialTable[ ID_TYP_VHW ] >> 8 ) & 0xF;

	wsprintf( (LPTSTR)sup.sz__uid_model, "%s %s", DRIVER_UPS_PREFIX, szUpsName[ i-1 ] );
	wsprintf( (LPTSTR)sup.sz__uid_family, "%s", DRIVER_UPS_FAMILY );

	iv[0] = ( lpuiSpecialTable[ ID_TYP_VHW ] & 0xFF ) >> 4;
	iv[1] = ( lpuiSpecialTable[ ID_TYP_VHW ] & 0x0F );
	iv[2] = ( lpuiSpecialTable[ MAGIC_NUMBER ] >> 12 ) & 0xF;
	iv[3] = ( lpuiSpecialTable[ MAGIC_NUMBER ] >> 8 ) & 0xF;
	iv[4] = ( lpuiSpecialTable[ MAGIC_NUMBER ] & 0xFF );
	wsprintf( (LPTSTR)sup.sz__uid_version, 
		"Hardware: %d.%d  Firmware: %d.%d b%d", iv[0], iv[1], iv[2], iv[3], iv[4] );

	sup.ui__frq_input = lpuiInfoTable[ F_WEJ ];
	sup.ui__frq_input_div = 10;
	sup.ui__frq_output = lpuiSetupTable[ F_WYJ ];
	sup.ui__frq_output_div = 10;

	sup.ui__load_output = (lpuiInfoTable[ OBCIAZENIE ] * lpuiCharTable[ P_WYJ_MAX ]) / 100;
	sup.ui__load_output_div = 1;
	sup.ui__ov_extmodules = lpuiInfoTable[ DOD_MOD ];
	sup.ui__ov_extmodules_div = 1;
	sup.ui__prc_batterycapacity = lpuiInfoTable[ POJ_AKU ];
	sup.ui__prc_batterycapacity_div = 1;
	sup.ui__prc_powerweight = lpuiInfoTable[ OBCIAZENIE ];
	sup.ui__prc_powerweight_div = 1;

	sup.ui__pst_avrlow = lpuiSetupTable[ V_DOLNY_AVR ];
	sup.ui__pst_avrup = lpuiSetupTable[ V_GORNY_AVR ];
	sup.ui__pst_avrlow_div = sup.ui__pst_avrup_div = 1;
	sup.ui__pst_lower = lpuiSetupTable[ V_DOLNY ];
	sup.ui__pst_upper = lpuiSetupTable[ V_GORNY ];
	sup.ui__pst_lower_div = sup.ui__pst_upper_div = 1;

	/* czulosc:
	 * 0 = mala = 0x00; 1 = srednia = 0x0F; 2 = duza = 0xF0;
	 */
	switch(lpuiSetupTable[ CZULOSC ])
	{
	case 0x00: sup.ui__sns_frequency = sup.ui__sns_voltage = 0; break;
	case 0x0F: sup.ui__sns_frequency = sup.ui__sns_voltage = 1; break;
	case 0xF0: sup.ui__sns_frequency = sup.ui__sns_voltage = 2; break;
	}
	sup.ui__sns_frequency_div = sup.ui__sns_voltage_div = 1;

	sup.ui__tmp_casing = lpuiInfoTable[ TEMPERATURA_OT ];
	sup.ui__tmp_casing_div = 1;
	sup.ui__tmp_inverter = lpuiInfoTable[ TEMPERATURA ];
	sup.ui__tmp_inverter_div = 1;

	/* czas autonomi w sek. */
	sup.ui__tmv_autonomy = lpuiInfoTable[ CZAS_PRACY ];
	sup.ui__tmv_autonomy_div = 1;

	sup.ui__vlt_battery = lpuiInfoTable[ V_AKU ];
	sup.ui__vlt_battery_div = 10;
	sup.ui__vlt_input = lpuiInfoTable[ V_WEJ ];
	sup.ui__vlt_input_div = 1;
	sup.ui__vlt_output = lpuiInfoTable[ V_WYJ ];
	sup.ui__vlt_output_div = 1;

	memcpy( lpvBuff, &sup, sizeof(supsp) );

	delete [] lpuiInfoTable;
	delete [] lpuiSetupTable;
	delete [] lpuiCharTable;
	delete [] lpuiSpecialTable;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetUpsSetupParamsMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsSetupParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long	ulMask = UP_SET_PST_UPPER | UP_SET_PST_LOWER | UP_SET_PST_AVRUP | 
		UP_SET_PST_AVRLOW | UP_SET_AAL_ON | UP_SET_TMR_POWERFAILTOSTANDBY | 
		UP_SET_FRQ_OUTPUT | UP_SET_SNS_VOLTAGE | UP_SET_SNS_FREQUENCY;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUpsSetupParamsMask
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetUpsSetupParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: DoGetUpsSetupParams
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsSetupParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int	*lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	int				iSize = UPS_SETUP_COUNT;
	int				iRet;
	supssp			susp;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof(unsigned int) * UPS_SETUP_COUNT)
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = DoGetUPSStructures(EU_SETUP, lpuiSetupTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiSetupTable;
		return iRet;
	}

	susp.ulMask = UP_SET_PST_UPPER | UP_SET_PST_LOWER | UP_SET_PST_AVRUP | 
		UP_SET_PST_AVRLOW | UP_SET_AAL_ON | UP_SET_TMR_POWERFAILTOSTANDBY | 
		UP_SET_FRQ_OUTPUT | UP_SET_SNS_VOLTAGE | UP_SET_SNS_FREQUENCY;
	
	susp.ui__set_pst_upper = lpuiSetupTable[ V_GORNY ];
	susp.ui__set_pst_lower = lpuiSetupTable[ V_DOLNY ];
	susp.ui__set_pst_upper_div = susp.ui__set_pst_lower_div = 1;

	susp.ui__set_pst_avrlow = lpuiSetupTable[ V_DOLNY_AVR ];
	susp.ui__set_pst_avrup = lpuiSetupTable[ V_GORNY_AVR ];
	susp.ui__set_pst_avrlow_div = susp.ui__set_pst_avrup_div = 1;

	susp.ui__set_aal_on = (lpuiSetupTable[ KONTROLA_PRACY ] & 0x40) ? 1 : 0;
	susp.ui__set_tmr_powerfailtostandby = lpuiSetupTable[ OPOZNIENIE_STANDBY ];
	susp.ui__set_tmr_powerfailtostandby_div = 1;
	susp.ui__set_frq_output = lpuiSetupTable[ F_WYJ ];
	susp.ui__set_frq_output_div = 10;

	switch(lpuiSetupTable[ CZULOSC ])
	{
	case 0x00: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 0; break;
	case 0x0F: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 1; break;
	case 0xF0: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 2; break;
	}
	susp.ui__set_sns_frequency_div = susp.ui__set_sns_voltage_div = 1;

	memcpy( lpvBuff, &susp, *lpiBuffSize );

	delete [] lpuiSetupTable;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUpsSetupParams
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetUpsSetupParams(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetDriverInfo
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetDriverInfo(void *lpvBuff, int *lpiBuffSize)
{
	if (*lpiBuffSize != sizeof(sdrv_info))
		return IOCTL_ERROR_INVALIDARGUMENT;
	wsprintf( (LPTSTR)(( lpsdrv_info )lpvBuff )->szName, "%s DRIVER", DRIVER_UPS_PREFIX );
	wsprintf( (LPTSTR)(( lpsdrv_info )lpvBuff )->szFamily, "%s", DRIVER_UPS_FAMILY );
	((lpsdrv_info)lpvBuff)->eLink = ul_serial;
	((lpsdrv_info)lpvBuff)->uisddxDlgConfigCnt = 0;
	((lpsdrv_info)lpvBuff)->uismecEventsConfigCnt = 0;
	((lpsdrv_info)lpvBuff)->uiVersionMajor = DRIVER_VERSION_MAJOR;
	((lpsdrv_info)lpvBuff)->uiVersionMinor = DRIVER_VERSION_MINOR;
	memcpy( &(( lpsdrv_info )lpvBuff )->sDcb, &dcbSinlinexl, sizeof( DCB ) );

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetExtendedError
// Description		: Get extended error information - return value of last error
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetExtendedError(void *lpvBuff, int *lpiBuffSize)
{
	return iExtError;
}

// Function name	: DoGetUpsCharacteristicMask
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsCharacteristicMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long	ulMask = UC_POWEROUT_MAX | UC_ADDMOD_MAXCAP	| UC_PST_LOWER_MIN |
		UC_PST_LOWER_MAX | UC_PST_UPPER_MIN	| UC_PST_UPPER_MAX | UC_PST_AVRUP_MIN |
		UC_PST_AVRDOWN_MAX | UC_INFREQ_MIN | UC_INFREQ_MAX | UC_OUTFREQ_MIN | 
		UC_OUTFREQ_MAX | UC_OUTVOLTAGE | UC_ACCUFULLCAPVOLTAGE;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetUpsCharacteristic
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetUpsCharacteristic(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int	*lpuiInfoTable = new unsigned int[UPS_CHARAKTER_COUNT];
	int				iSize = UPS_CHARAKTER_COUNT;
	int				iRet;
	supsch			such;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( supsch ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = DoGetUPSStructures(EU_CHARACTERISTIC, lpuiInfoTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		return iRet;
	}
	
	memset( &such, 0, sizeof(supsch) );

	such.ulMask = UC_POWEROUT_MAX | UC_ADDMOD_MAXCAP	| UC_PST_LOWER_MIN |
		UC_PST_LOWER_MAX | UC_PST_UPPER_MIN	| UC_PST_UPPER_MAX | UC_PST_AVRUP_MIN |
		UC_PST_AVRDOWN_MAX | UC_INFREQ_MIN | UC_INFREQ_MAX | UC_OUTFREQ_MIN | 
		UC_OUTFREQ_MAX | UC_OUTVOLTAGE | UC_ACCUFULLCAPVOLTAGE;

	such.ui__addmod_maxcap = lpuiInfoTable[DOD_MOD_MAX];
	such.ui__addmod_maxcap_div = 1;
	such.ui__accufullcapvoltage = lpuiInfoTable[V_AKU_FULL];
	such.ui__accufullcapvoltage_div = 1;
	such.ui__infreq_max = such.ui__outfreq_max = lpuiInfoTable[F_MAX];
	such.ui__infreq_max_div = such.ui__outfreq_max_div = 1;
	such.ui__infreq_min = such.ui__outfreq_min = lpuiInfoTable[F_MIN];
	such.ui__infreq_min_div = such.ui__outfreq_min_div = 1;
	such.ui__outvoltage = lpuiInfoTable[V_WYJ_NOM];
	such.ui__outvoltage_div = 1;
	such.ui__powerout_max = lpuiInfoTable[P_WYJ_MAX];
	such.ui__powerout_max_div = 1;
	such.ui__pst_avrdown_max = lpuiInfoTable[V_AVRDOWN_MAX];
	such.ui__pst_avrdown_max_div = 1;
	such.ui__pst_avrup_min = lpuiInfoTable[V_AVRUP_MIN];
	such.ui__pst_avrup_min_div = 1;
	such.ui__pst_lower_max = lpuiInfoTable[V_DOLNY_MAX];
	such.ui__pst_lower_max_div = 1;
	such.ui__pst_lower_min = lpuiInfoTable[V_DOLNY_MIN];
	such.ui__pst_lower_min_div = 1;
	such.ui__pst_upper_max = lpuiInfoTable[V_GORNY_MAX];
	such.ui__pst_upper_max_div = 1;
	such.ui__pst_upper_min = lpuiInfoTable[V_GORNY_MIN];
	such.ui__pst_upper_min_div = 1;

	memcpy( lpvBuff, &such, *lpiBuffSize );
	delete [] lpuiInfoTable;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoTestUpsLink
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoTestUpsLink(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	int	iSize = UPS_INF_COUNT, iRet;

	iRet = DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &iSize);
	delete [] lpuiInfoTable;

	return iRet;
}

// Function name	: DoGetUPSStructures
// Description		: Return specified structure from UPS
// Return type		: int 
// Argument         : eups_structs eType
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int DoGetUPSStructures(eups_structs eType, void *lpvBuff, int *lpiBuffSize)
{
/* 
 * Helper macros
 */
#undef COMMIOFAIL
#define COMMIOFAIL( v, en ) { if ( COMMFAIL( v ) ) {	\
	iExtError = en; return IOCTL_ERROR_COMM_LINKFAIL; } }

	unsigned char	ucDataBuff[0xFF] = { 0 },
					ucLength = 0,
					ucCRC = 0;
	unsigned int	uiDataBuff[0xFF] = { 0 };
	unsigned long	ulCRC = 0;
	BOOL			bInitialized = FALSE;
	
	if (!ccSinlinexl.IsInitialized())
		return IOCTL_ERROR_NOTYETINITIALIZED;

	//CheckForUPSConfigUpdate();
	/* 
	 * Zapytanie UPS'a
	 */
	for (int i = 0; i < 4; i++)
	{
		ucDataBuff[0] = 0;

		ccSinlinexl.PurgeInput();
		ccSinlinexl.PurgeOutput();

		COMMIOFAIL( ccSinlinexl.Send(FRAME_INITCODE), IOCTL_ERROR_COMM_FAILTOSEND );
		COMMIOFAIL( ccSinlinexl.Recv(&ucDataBuff[0]), IOCTL_ERROR_COMM_FAILTORECEIVE )

		if (ucDataBuff[0] == FRAME_INITCODE)
		{
			bInitialized = TRUE;
			break;
		}
		WaitToTimeout(20);
	}
	if (!bInitialized)
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDCODE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( ccSinlinexl.Send( FRAME_START ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucLength = 3;
	COMMIOFAIL( ccSinlinexl.Send( ucLength ), IOCTL_ERROR_COMM_FAILTOSEND );
	COMMIOFAIL( ccSinlinexl.Send( FRAME_CMD_GET ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += FRAME_CMD_GET;
	COMMIOFAIL( ccSinlinexl.Send( eType ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += eType;
	ucCRC %= 256;
	COMMIOFAIL( ccSinlinexl.Send( ucCRC ), IOCTL_ERROR_COMM_FAILTOSEND );
	/* 
	 * Odpowiedz od UPS'a
	 */
	ucDataBuff[0] = ucDataBuff[1] = ucDataBuff[2] = 0;
	COMMIOFAIL( ccSinlinexl.Recv( &ucDataBuff[0] ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	if (ucDataBuff[0] != FRAME_START)
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDFRAME;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	
	COMMIOFAIL( ccSinlinexl.Recv( &ucLength ), IOCTL_ERROR_COMM_FAILTORECEIVE );

	/* :: length = (length - crc_byte) / 2 */
	if ( ((ucLength - 1) / 2) > *lpiBuffSize )
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDLENGTH;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( ccSinlinexl.Recv2b( uiDataBuff, (ucLength - 1) / 2, &ulCRC ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	COMMIOFAIL( ccSinlinexl.Recv( &ucCRC ), IOCTL_ERROR_COMM_FAILTORECEIVE );

	ulCRC %= 256;
	if (ulCRC != ucCRC)
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDCRC;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	
	memcpy( lpvBuff, &uiDataBuff, *lpiBuffSize * sizeof( unsigned int ) );

	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetUPSStructures
// Description		: 
// Return type		: int 
// Argument         : eups_structs eType
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
// Argument         : int *lpiBuffErrPos
int DoSetUPSStructures(eups_structs eType, void *lpvBuff, int *lpiBuffSize, int *lpiBuffErrPos )
{
/* 
 * Helper macros
 */
#undef COMMIOFAIL
#define COMMIOFAIL( v, en ) { if ( COMMFAIL( v ) ) {	\
	iExtError = en; return IOCTL_ERROR_COMM_LINKFAIL; } }

	unsigned char	ucDataBuff[0xFF] = { 0 },
					ucLength = 0,
					ucErrCode = 0,
					ucCRC = 0;
	unsigned int	uiDataBuff[0xFF] = { 0 };
	unsigned long	ulCRC = 0;
	BOOL			bInitialized = FALSE;
	
	if ( !ccSinlinexl.IsInitialized() )
		return IOCTL_ERROR_NOTYETINITIALIZED;

	if ( !lpvBuff )
		return IOCTL_ERROR_INVALIDARGUMENT;
	memcpy( &uiDataBuff, lpvBuff, *lpiBuffSize * sizeof(unsigned int));
	/* 
	 * Zapytanie UPS'a
	 */
	for (int i = 0; i < 4; i++)
	{
		ucDataBuff[0] = 0;

		ccSinlinexl.PurgeInput();
		ccSinlinexl.PurgeOutput();

		COMMIOFAIL( ccSinlinexl.Send(FRAME_INITCODE), IOCTL_ERROR_COMM_FAILTOSEND );
		COMMIOFAIL( ccSinlinexl.Recv(&ucDataBuff[0]), IOCTL_ERROR_COMM_FAILTORECEIVE )

		if (ucDataBuff[0] == FRAME_INITCODE)
		{
			bInitialized = TRUE;
			break;
		}
		WaitToTimeout(20);
	}
	if (!bInitialized)
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDCODE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( ccSinlinexl.Send( FRAME_START ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucLength = 3 + (*lpiBuffSize * 2);
	ucCRC = 0;
	COMMIOFAIL( ccSinlinexl.Send( ucLength ), IOCTL_ERROR_COMM_FAILTOSEND );
	COMMIOFAIL( ccSinlinexl.Send( FRAME_CMD_SET ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += FRAME_CMD_SET;
	COMMIOFAIL( ccSinlinexl.Send( eType ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += eType;
	COMMIOFAIL( ccSinlinexl.Send2b( (unsigned int *)lpvBuff, *lpiBuffSize ), IOCTL_ERROR_COMM_FAILTOSEND );
	for ( int j = 0; j < *lpiBuffSize; j++ )
		ucCRC += (LOBYTE(uiDataBuff[j]) + HIBYTE(uiDataBuff[j]));
	ucCRC %= 256;
	COMMIOFAIL( ccSinlinexl.Send( ucCRC ), IOCTL_ERROR_COMM_FAILTOSEND );
	/* 
	 * Odpowiedz od UPS'a
	 */
	ucDataBuff[0] = ucDataBuff[1] = ucDataBuff[2] = 0;
	COMMIOFAIL( ccSinlinexl.Recv( &ucDataBuff[0] ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	if (ucDataBuff[0] != FRAME_START)
	{
		iExtError = IOCTL_ERROR_COMM_INVALIDFRAME;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( ccSinlinexl.Recv( &ucErrCode ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	switch( ucErrCode )
	{
	case 0x05:	// Nieprawidowa ilo�bajtw w ramce
		iExtError = IOCTL_ERROR_COMM_BADFRAMELENGTH;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x0A:	// Nieznany typ rozkazu
		iExtError = IOCTL_ERROR_COMM_UNKNOWNCOMMANDTYPE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x15:	// Nieznany rozkaz
		iExtError = IOCTL_ERROR_COMM_UNKNOWNCOMMAND;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x20:	// Bd CRC
		iExtError = IOCTL_ERROR_COMM_BADCRC;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x5F:	// Data integrity error
		COMMIOFAIL( ccSinlinexl.Recv( &ucErrCode ), IOCTL_ERROR_COMM_FAILTORECEIVE );
		if ( lpiBuffErrPos != NULL )
			*lpiBuffErrPos = ucErrCode;
		iExtError = IOCTL_ERROR_COMM_DATAINTEGRITY;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0xFF:	// Success = no error
		break;;
	}

	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DlgProc_Config
// Description		: 
// Return type		: BOOL CALLBACK 
// Argument         : HWND hDlg
// Argument         : UINT uMsg
// Argument         : WPARAM wParam
// Argument         : LPARAM lParam
BOOL CALLBACK DlgProc_Config(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		{
			int	iItem, icnt;
			char szStr[256];
			
			icnt = 0;
			for (icnt = 1; icnt < 32; icnt++)
			{
				sprintf( szStr, "COM%d", icnt );
				iItem = SendDlgItemMessage( hDlg, IDC_COMBOPORT, CB_ADDSTRING, 0, (LPARAM)szStr );
				if ( iItem != CB_ERR)
					SendDlgItemMessage( hDlg, IDC_COMBOPORT, CB_SETITEMDATA, iItem, (LPARAM)icnt-1 );
			}
			sprintf( szStr, "COM%d", lParam - 1 );
			iItem = SendDlgItemMessage(
				hDlg, IDC_COMBOPORT, CB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)szStr );
			if ( iItem != CB_ERR )
				SendDlgItemMessage(hDlg, IDC_COMBOPORT, CB_SETCURSEL, (WPARAM)iItem, 0);
			return TRUE;
		}

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			{
				int iItem = SendDlgItemMessage( hDlg, IDC_COMBOPORT, CB_GETCURSEL, 0, 0 );
				if ( iItem != CB_ERR )
				{
					EndDialog( hDlg, SendDlgItemMessage( 
						hDlg, IDC_COMBOPORT, CB_GETITEMDATA, iItem, 0 ) + 1 );
				}
				break;
			}
		
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
		break;

	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return FALSE;
}

// Function name	: DoGetConfigParamsCount
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetConfigParamsCount(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulCount = INT_MAX_SETUPITEMS;

	if ( lpiBuffSize != NULL )
		if ( *lpiBuffSize < sizeof( unsigned long ) )
			return IOCTL_ERROR_INVALIDARGUMENT;

	memcpy( lpvBuff, &ulCount, sizeof( ulCount ) );

	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetConfigParams
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetConfigParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	unsigned int *lpuiCharTable = new unsigned int[UPS_CHARAKTER_COUNT];
	int	iSize, iRet;
	scfg_value scfgvaldef[ INT_MAX_SETUPITEMS ];
	char	szDrvCfgPath[MAX_PATHBUFF];
	unsigned long	ulSize;
	CWinUtil cUtil;
	CPRegistry	cpReg;
	DWORD dwSize1, dwSize2;
	char szStr[512], szKeyName[256];
	int	icnt;
	HKEY hKey;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( scfgvaldef ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	if (!ccSinlinexl.IsInitialized())
	{
		if (GetStartupDir(szDrvCfgPath) < 0)
			return IOCTL_ERROR;
		strcat(szDrvCfgPath, DRIVER_CONFIG_FILE);
		if (!FileExists(szDrvCfgPath))
			return IOCTL_ERROR_NOTYETCONFIGURED;
		ulSize = sizeof(sdcSinlinexl);
		if (!cUtil.ReadFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
			return IOCTL_ERROR;

		memcpy( lpuiSetupTable, &sdcSinlinexl.iSetupTable, sizeof(sdcSinlinexl.iSetupTable) );
		memcpy( lpuiCharTable, &sdcSinlinexl.iCharacterTable, sizeof(sdcSinlinexl.iCharacterTable) );
	}
	else
	{
		iSize = UPS_SETUP_COUNT;
		iRet = DoGetUPSStructures(EU_SETUP, lpuiSetupTable, &iSize);
		if (iRet != IOCTL_ERROR_SUCCESS)
		{
			delete [] lpuiSetupTable;
			delete [] lpuiCharTable;
			return iRet;
		}
		iSize = UPS_CHARAKTER_COUNT;
		iRet = DoGetUPSStructures(EU_CHARACTERISTIC, lpuiCharTable, &iSize);
		if (iRet != IOCTL_ERROR_SUCCESS)
		{
			delete [] lpuiSetupTable;
			delete [] lpuiCharTable;
			return iRet;
		}
	}

	/* Port komunikacyjny */
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_SERIALCOMM ].szName, TXT_CFG_COMMUNICATIONPORT);
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].value.iValue = (int)sdcSinlinexl.iSerialPort-1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].range.lMin = 0;

	hKey = cpReg.Open(HKLM, "HARDWARE\\DEVICEMAP\\SERIALCOMM", KEY_QUERY_VALUE);
	if (!hKey)
		return IOCTL_ERROR;
	icnt = 0;
	while(icnt < 8)
	{
		dwSize1 = sizeof(szKeyName);
		dwSize2 = sizeof(szStr);
		if (RegEnumValue(hKey, icnt, szKeyName, &dwSize1, NULL, NULL, 
			(LPBYTE)szStr, &dwSize2) == ERROR_NO_MORE_ITEMS)
			break;
		strcpy(scfgvaldef[ INT_UPSCFG_SERIALCOMM ].list[icnt].szName, szStr);

		scfgvaldef[ INT_UPSCFG_SERIALCOMM ].list[icnt].iValue = ( int )( *( szStr + 3 ) - 49 );
		icnt++;
	}
	cpReg.Close(hKey);
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].range.lMax = icnt-1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].iListItems = icnt;

	/* KONTROLA_PRACY:buzer */
	scfgvaldef[ INT_UPSCFG_BUZZER ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].szName, TXT_CFG_SOUNDALERT);
	scfgvaldef[ INT_UPSCFG_BUZZER ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_BUZZER ].value.iValue = 
		(int)(TestBit(lpuiSetupTable[KONTROLA_PRACY], FLAG_KONTROLA_PRACY_BUZZER) ? 1 : 0);
	scfgvaldef[ INT_UPSCFG_BUZZER ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_BUZZER ].range.lMax = 1;
	scfgvaldef[ INT_UPSCFG_BUZZER ].iListItems = 2;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].list[0].szName, TXT_CFG_DISABLED);
	scfgvaldef[ INT_UPSCFG_BUZZER ].list[0].iValue = 0;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].list[1].szName, TXT_CFG_ENABLED);
	scfgvaldef[ INT_UPSCFG_BUZZER ].list[1].iValue = 1;

	/* F_WYJ */
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].szName, TXT_CFG_OUTPUTFREQ);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider = 10;
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].value.iValue = (int)(lpuiSetupTable[ F_WYJ ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].range.lMin = (long)(lpuiCharTable[ F_MIN ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].range.lMax = (long)(lpuiCharTable[ F_MAX ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].iListItems = 0;

	/* CZULOSC */
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].szName, TXT_CFG_SENSITIVITY);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].dDivider = 1;

	/*
	switch( (int)(lpuiSetupTable[CZULOSC] / scfgvaldef[ INT_UPSCFG_SENSITIVITY ].dDivider) )
	{
	case 0x00:
		scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = 0;
		break;
	case 0x0F:
		scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = 1;
		break;
	case 0xF0:
		scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = 2;
		break;
	default:
		scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = 1;
		break;
	}
	*/
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = lpuiSetupTable[ CZULOSC ];
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].range.lMin = 0x00;
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].range.lMax = 0xF0;
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].iListItems = 3;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[0].szName, TXT_CFG_SENS_LOW);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[0].iValue = 0x00;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[1].szName, TXT_CFG_SENS_AVERAGE);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[1].iValue = 0x0F;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[2].szName, TXT_CFG_SENS_HIGH);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[2].iValue = 0xF0;

	/* V_DOLNY */
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_DOLNY ].szName, TXT_CFG_POWERSTATELOWER);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].value.iValue = (int)(lpuiSetupTable[ V_DOLNY ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].range.lMin = (long)(lpuiCharTable[ V_DOLNY_MIN ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].range.lMax = (long)(lpuiCharTable[ V_DOLNY_MAX ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].iListItems = 0;
	
	/* V_GORNY */
	scfgvaldef[ INT_UPSCFG_V_GORNY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_GORNY ].szName, TXT_CFG_POWERSTATEUPPER);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_GORNY ].value.iValue = (int)(lpuiSetupTable[ V_GORNY ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].range.lMin = (long)(lpuiCharTable[ V_GORNY_MIN ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].range.lMax = (long)(lpuiCharTable[ V_GORNY_MAX ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].iListItems = 0;

	/* V_DOLNY_AVR */
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].szName, TXT_CFG_AVR_LOWER);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].value.iValue = (int)(lpuiSetupTable[ V_DOLNY_AVR ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].range.lMin = (long)(lpuiSetupTable[ V_DOLNY ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].range.lMax = (long)(lpuiCharTable[ V_AVRDOWN_MAX ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].iListItems = 0;

	/* V_GORNY_AVR */
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].szName, TXT_CFG_AVR_UPPER);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].value.iValue = (int)(lpuiSetupTable[ V_GORNY_AVR ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].range.lMin = (long)(lpuiCharTable[ V_AVRUP_MIN ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].range.lMax = (long)(lpuiSetupTable[ V_GORNY ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].iListItems = 0;

	/* OPOZNIENIE_STANDBY */
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].szName, TXT_CFG_STANDBYTIMEOUT);
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue = (int)(lpuiSetupTable[ OPOZNIENIE_STANDBY ] / scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider);
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].range.lMax = 32767;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].iListItems = 0;

	/* KONTROLA_PRACY:shutdown */
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].szName, TXT_CFG_UPSONOFF);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].value.iValue = 
		(int)(TestBit(lpuiSetupTable[KONTROLA_PRACY], FLAG_KONTROLA_PRACY_SHUTDOWN) ? 1 : 0);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].range.lMax = 1;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].iListItems = 2;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[0].szName, TXT_CFG_DISABLED);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[0].iValue = 0;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[1].szName, TXT_CFG_ENABLED);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[1].iValue = 1;

	/* LOW_BATTERY TRESHOLD */
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].szName, TXT_CFG_LOWBATTERYTRANSFERTRESHOLD);
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].value.iValue = (int)( sdcSinlinexl.uiBattCapToLB );
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].range.lMin = 1;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].range.lMax = 100;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].iListItems = 0;
	
	memcpy( lpvBuff, scfgvaldef, *lpiBuffSize );

	delete [] lpuiSetupTable;
	delete [] lpuiCharTable;

	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetConfigParams
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetConfigParams(void *lpvBuff, int *lpiBuffSize)
{
	int	iSize, iRet;
	unsigned long ulSize;
	scfg_value scfgvaldef[ INT_MAX_SETUPITEMS ];
	char szDrvCfgPath[MAX_PATHBUFF];
	CWinUtil cUtil;

	if ( *lpiBuffSize != (sizeof(scfg_value) * INT_MAX_SETUPITEMS) )
		return IOCTL_ERROR_INVALIDARGUMENT;
	else
		memcpy( &scfgvaldef, lpvBuff, *lpiBuffSize );

	if (!ccSinlinexl.IsInitialized())
	{
		if (GetStartupDir(szDrvCfgPath) < 0)
			return IOCTL_ERROR;
		strcat(szDrvCfgPath, DRIVER_CONFIG_FILE);
		if (!FileExists(szDrvCfgPath))
			return IOCTL_ERROR_NOTYETCONFIGURED;
		ulSize = sizeof(sdcSinlinexl);
		if (!cUtil.ReadFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
			return IOCTL_ERROR;
	}
	else
	{
		iSize = UPS_SETUP_COUNT;
		iRet = DoGetUPSStructures(EU_SETUP, &sdcSinlinexl.iSetupTable, &iSize);
		if (iRet != IOCTL_ERROR_SUCCESS)
		{
			return iRet;
		}
	}

	/* Port komunikacyjny */
	sdcSinlinexl.iSerialPort = scfgvaldef[ INT_UPSCFG_SERIALCOMM ].value.iValue + 1;
	/* KONTROLA_PRACY:buzer */
	if (scfgvaldef[ INT_UPSCFG_BUZZER ].value.iValue == 1)
		sdcSinlinexl.iSetupTable[ KONTROLA_PRACY ] |= FLAG_KONTROLA_PRACY_BUZZER;
	else
		sdcSinlinexl.iSetupTable[ KONTROLA_PRACY ] &= ~(FLAG_KONTROLA_PRACY_BUZZER);
	/* KONTROLA_PRACY:shutdown */
	if (scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].value.iValue == 1)
		sdcSinlinexl.iSetupTable[ KONTROLA_PRACY ] |= FLAG_KONTROLA_PRACY_SHUTDOWN;
	else
		sdcSinlinexl.iSetupTable[ KONTROLA_PRACY ] &= ~(FLAG_KONTROLA_PRACY_SHUTDOWN);
	/* F_WYJ */
	sdcSinlinexl.iSetupTable[F_WYJ] = (int)( scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider );
	/* CZULOSC */
	sdcSinlinexl.iSetupTable[ CZULOSC ] = scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue;
	/*if (scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue == 0)
		sdcSinlinexl.iSetupTable[ CZULOSC ] = 0x00;
	else if (scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue == 1)
		sdcSinlinexl.iSetupTable[ CZULOSC ] = 0x0F;
	else if (scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue == 2)
		sdcSinlinexl.iSetupTable[ CZULOSC ] = 0xF0;
	else
		sdcSinlinexl.iSetupTable[ CZULOSC ] = 0x0F;
	*/
	/* V_DOLNY */
	sdcSinlinexl.iSetupTable[ V_DOLNY ] = (int)(scfgvaldef[ INT_UPSCFG_V_DOLNY ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	/* V_GORNY */
	sdcSinlinexl.iSetupTable[ V_GORNY ] = (int)(scfgvaldef[ INT_UPSCFG_V_GORNY ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	/* V_DOLNY_AVR */
	sdcSinlinexl.iSetupTable[ V_DOLNY_AVR ] = (int)(scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	/* V_GORNY_AVR */
	sdcSinlinexl.iSetupTable[ V_GORNY_AVR ] = (int)(scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	/* OPOZNIENIE_STANDBY */
	if ((int)(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue) < 60)
	{
		cUtil.MsgAlert( TXT_WARNING, TXT_INF_STANDBYTIMETOSHORT );
	}
	sdcSinlinexl.iSetupTable[ OPOZNIENIE_STANDBY ] = (int)(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue *
		scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider);
	/* LOW BATTERY */
	sdcSinlinexl.uiBattCapToLB = ( unsigned int )(scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].value.iValue *
		scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].dDivider);

	if (!ccSinlinexl.IsInitialized())
	{
		sdcSinlinexl.bDrvToUpdate = TRUE;
		if (GetStartupDir(szDrvCfgPath) < 0)
			return IOCTL_ERROR;
		strcat(szDrvCfgPath, DRIVER_CONFIG_FILE);
		if (!FileExists(szDrvCfgPath))
			return IOCTL_ERROR_NOTYETCONFIGURED;
		ulSize = sizeof(sdcSinlinexl);
		if (!cUtil.WriteFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
			return IOCTL_ERROR;
	}
	else
	{
		iSize = UPS_SETUP_COUNT;
		iRet = DoSetUPSStructures(EU_SETUP, sdcSinlinexl.iSetupTable, &iSize, NULL);
		if (iRet != IOCTL_ERROR_SUCCESS)
			return iRet;
		sdcSinlinexl.bDrvToUpdate = FALSE;
		if (GetStartupDir(szDrvCfgPath) < 0)
			return IOCTL_ERROR;
		strcat(szDrvCfgPath, DRIVER_CONFIG_FILE);
		if (!FileExists(szDrvCfgPath))
			return IOCTL_ERROR_NOTYETCONFIGURED;
		ulSize = sizeof(sdcSinlinexl);
		if (!cUtil.WriteFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
			return IOCTL_ERROR;
	}

	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetConfigParam
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetConfigParam(void *lpvBuff, int *lpiBuffSize)
{
	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoSetConfigParam
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoSetConfigParam(void *lpvBuff, int *lpiBuffSize)
{
	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoUpdateConfig
// Description		: 
// Return type		: 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoUpdateConfig(void *lpvBuff, int *lpiBuffSize)
{
	iExtError = 0;
	
	if (!ccSinlinexl.IsInitialized())
		return IOCTL_ERROR_NOTYETINITIALIZED;

	CheckForUPSConfigUpdate();

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: CheckForUPSConfigUpdate
// Description		: 
// Return type		: int 
int CheckForUPSConfigUpdate()
{
	char szDrvCfgPath[MAX_PATHBUFF];
	int iSize, iRet;
	unsigned long ulSize;
	CWinUtil cUtil;

	PrintDebugString( "DRV: Checking for update" );

	if (sdcSinlinexl.bDrvSlaveMode)
		return IOCTL_ERROR_SUCCESS;

	if (GetStartupDir(szDrvCfgPath) < 0)
		return IOCTL_ERROR;

	strcat(szDrvCfgPath, DRIVER_CONFIG_FILE);
	if (!FileExists(szDrvCfgPath))
		return IOCTL_ERROR_NOTYETCONFIGURED;

	ulSize = sizeof(sdcSinlinexl);
	if (!cUtil.ReadFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
		return IOCTL_ERROR;

	/* Jeeli jest jaka aktualizacja parametrw to zaktualizuj */
	if (sdcSinlinexl.bDrvToUpdate)
	{
		PrintDebugString( "DRV: Updating" );
		iSize = UPS_SETUP_COUNT;
		iRet = DoSetUPSStructures(EU_SETUP, sdcSinlinexl.iSetupTable, &iSize, NULL);
		if (iRet == IOCTL_ERROR_SUCCESS)
		{
			sdcSinlinexl.bDrvToUpdate = FALSE;
			ulSize = sizeof(sdcSinlinexl);
			if (!cUtil.WriteFile(szDrvCfgPath, &sdcSinlinexl, 0, ulSize))
				return IOCTL_ERROR;
		}
	}
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoGetDriverMode
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	DoGetDriverMode(void *lpvBuff, int *lpiBuffSize)
{
	int iMode = ( sdcSinlinexl.bDrvSlaveMode ) ? DRV_MODE_SLAVE : DRV_MODE_MASTER;
	if ( *lpiBuffSize < sizeof( int ) )
		return IOCTL_ERROR_INVALIDARGUMENT;
	memcpy( lpvBuff, &iMode, sizeof( int ) );
	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: DoUpsShutdown
// Description		: 
// Return type		: int 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int DoUpsShutdown(void *lpvBuff, int *lpiBuffSize)
{
	CWinUtil cUtil;
	unsigned int *lpuiSetupTable = new unsigned int[ UPS_SETUP_COUNT ];
	int iRet, iSize = UPS_SETUP_COUNT;

	iRet = DoGetUPSStructures( EU_SETUP, lpuiSetupTable, &iSize );
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiSetupTable;
		return iRet;
	}
	
	/* KONTROLA_PRACY:shutdown */
	lpuiSetupTable[ KONTROLA_PRACY ] |= 0x08;

	iSize = UPS_SETUP_COUNT;
	iRet = DoSetUPSStructures( EU_SETUP, lpuiSetupTable, &iSize, NULL );
	if ( iRet != IOCTL_ERROR_SUCCESS )
		return iRet;

	delete [] lpuiSetupTable;
	iExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

