/***************************************************************************
 *   Copyright (C) 2004 by EVER Sp. z o.o.                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include "ccomm.h"
#include "conf.h"
#include "common.h"

#define SINLINEXL_DRIVER_BUILD 1
#include "sinlinexl.h"

/* 
 * Deklaracje zmiennych globalnych
 */
sdrv_config sdcSinlinexl;
bool bSinlineXL_FirmUns_Pass = false;
int iSinlineXL_FirmRev = 0;
int iSinlineXL_UpsSeries = 0;
int iSinlinexl_ExtError = 0;
CComm	commSinlinexl;

int sinlinexl_ioctl(long lCommand, void *lpvBuff, int *lpiBuffSize)
{
	switch(lCommand)
	{
	case IOCTL_INIT: 
		return SinlineXL_DoInit(lpvBuff, lpiBuffSize);

	case IOCTL_UNINIT:
		return SinlineXL_DoUnInit(lpvBuff, lpiBuffSize);
		
	case IOCTL_GETCONFIGFILENAME:
		return SinlineXL_DoGetConfigFileName(lpvBuff, lpiBuffSize);

	case IOCTL_AUTOCONFIGURE: 
		return SinlineXL_DoAutoConfigure(lpvBuff, lpiBuffSize);

	case IOCTL_CONFIGURE: 
		return SinlineXL_DoConfigure(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSINFOMASK: 
		return SinlineXL_DoGetUpsInfoMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSINFOMASK:
		return SinlineXL_DoSetUpsInfoMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSTATESMASK:
		return SinlineXL_DoGetUpsStateMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSTATESMASK:
		return SinlineXL_DoSetUpsStateMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSTATE:
		return SinlineXL_DoGetUpsState(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSPARAMSMASK:
		return SinlineXL_DoGetUpsParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSPARAMSMASK:
		return SinlineXL_DoSetUpsParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSPARAMS:
		return SinlineXL_DoGetUpsParams(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSETUPPARAMSMASK:
		return SinlineXL_DoGetUpsSetupParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSETUPPARAMSMASK:
		return SinlineXL_DoSetUpsSetupParamsMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSSETUPPARAMS:
		return SinlineXL_DoGetUpsSetupParams(lpvBuff, lpiBuffSize);

	case IOCTL_SET_UPSSETUPPARAMS:
		return SinlineXL_DoSetUpsSetupParams(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSCHARCTERISTICMASK:
		return SinlineXL_DoGetUpsCharacteristicMask(lpvBuff, lpiBuffSize);

	case IOCTL_GET_UPSCHARCTERISTIC:
		return SinlineXL_DoGetUpsCharacteristic(lpvBuff, lpiBuffSize);

	case IOCTL_GET_DRIVER_INFO:
		return SinlineXL_DoGetDriverInfo(lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_INFORMATIONS:
		return SinlineXL_DoGetUPSStructures(EU_INFORMATIONS, lpvBuff, lpiBuffSize);

	case IOCTL_GET_TABLE_SETUP:
		return SinlineXL_DoGetUPSStructures(EU_SETUP, lpvBuff, lpiBuffSize);

	case IOCTL_GET_ERRORNO:
		return SinlineXL_DoGetExtendedError(lpvBuff, lpiBuffSize);

	case IOCTL_TESTUPSLINK:
		return SinlineXL_DoTestUpsLink(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAMSCOUNT:
		return SinlineXL_DoGetConfigParamsCount(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAMS:
		return SinlineXL_DoGetConfigParams(lpvBuff, lpiBuffSize);

	case IOCTL_GETCONFIGPARAM:
		return SinlineXL_DoGetConfigParam(lpvBuff, lpiBuffSize);

	case IOCTL_SETCONFIGPARAMS:
		return SinlineXL_DoSetConfigParams(lpvBuff, lpiBuffSize);

	case IOCTL_SETCONFIGPARAM:
		return SinlineXL_DoSetConfigParam(lpvBuff, lpiBuffSize);

	case IOCTL_UPDATECONFIG:
		return SinlineXL_DoUpdateConfig(lpvBuff, lpiBuffSize);

	case IOCTL_GETDRIVERMODE:
		return SinlineXL_DoGetDriverMode(lpvBuff, lpiBuffSize);

	case IOCTL_SHUTDOWNUPS:
		return SinlineXL_DoUpsShutdown(lpvBuff, lpiBuffSize);

	default:
		return IOCTL_ERROR_CMD_NOTSUPPORTED;
	}
}

// Function name	: SinlineXL_DoInit
// Description		: Inicjalizacja drivera
int SinlineXL_DoInit( void *lpvBuff, int *lpiBuffSize )
{
	iSinlinexl_ExtError = 0;

	iSinlineXL_UpsSeries=0;
	iSinlineXL_FirmRev=0;
	bSinlineXL_FirmUns_Pass=false;

	if (SinlineXL_ReadConfig() != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR_CONFIG_READFAIL;

	commSinlinexl.init(sdcSinlinexl.szSerialPort, B19200);
	if (commSinlinexl.open()!=COMM_SUCCESS) {
		iSinlinexl_ExtError=IOCTL_ERROR_COMM_INITFAIL;
		return IOCTL_ERROR;
	}
	
	iSinlinexl_ExtError=IOCTL_ERROR_COMM_READTABLES;
	int iSize=UPS_INF_COUNT;
	if (SinlineXL_DoGetUPSStructures(EU_INFORMATIONS, &sdcSinlinexl.uiInfTable, &iSize)!=IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SETUP_COUNT;
	if (SinlineXL_DoGetUPSStructures(EU_SETUP, &sdcSinlinexl.uiSetupTable, &iSize)!=IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SPECIAL_COUNT;
	if (SinlineXL_DoGetUPSStructures(EU_SPECIAL, &sdcSinlinexl.uiSpecialTable, &iSize)!=IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_SPRZET_COUNT;
	if (SinlineXL_DoGetUPSStructures(EU_HARDWARE, &sdcSinlinexl.uiHardwareTable, &iSize)!=IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;
	iSize = UPS_CHARAKTER_COUNT;
	if (SinlineXL_DoGetUPSStructures(EU_CHARACTERISTIC, &sdcSinlinexl.uiCharacterTable, &iSize)!=IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR;

	iSinlinexl_ExtError = 0;
	SinlineXL_DoUpdateConfig(NULL, NULL);

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoUnInit
// Description		: Deinicjalizacja drivera
int SinlineXL_DoUnInit( void *lpvBuff, int *lpiBuffSize )
{
	if (commSinlinexl.close()!=COMM_SUCCESS)
	{
		iSinlinexl_ExtError=0;
		return IOCTL_ERROR;
	}
	
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoUnInit
// Description		: 
int SinlineXL_DoGetConfigFileName( void *lpvBuff, int *lpiBuffSize )
{
	if (lpvBuff != NULL) {
		if ( *lpiBuffSize >= strlen(DRIVER_CONFIG_FILE) )
			strcpy((char *)lpvBuff, DRIVER_CONFIG_FILE );
		else
			return IOCTL_ERROR_INVALIDARGUMENT;
	} else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoAutoConfigure
// Description		: Self configure
int SinlineXL_DoAutoConfigure( void *lpvBuff, int *lpiBuffSize )
{
	sdcSinlinexl.iSerialPort=1;
	if (sdcSinlinexl.uiBattCapToLB == 0)
		sdcSinlinexl.uiBattCapToLB = 10;	// 10% to Low Battery signal
	sprintf( sdcSinlinexl.szSerialPort, "/dev/ttyS%d", sdcSinlinexl.iSerialPort );	

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoConfigure
// Description		: Configure driver to work properly with UPS
int SinlineXL_DoConfigure( void *lpvBuff, int *lpiBuffSize )
{
	sdcSinlinexl.iSerialPort=1;
	if (sdcSinlinexl.uiBattCapToLB == 0)
		sdcSinlinexl.uiBattCapToLB = 10;	// 10% to Low Battery signal
	sprintf( sdcSinlinexl.szSerialPort, "/dev/ttyS%d", sdcSinlinexl.iSerialPort );	

	SinlineXL_DoUnInit(NULL, NULL);
	SinlineXL_DoInit(NULL, NULL);

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetUpsInfoMask
// Description		: Zwraca informacje o wypelnieniu struktury informacji o UPS-ie
int SinlineXL_DoGetUpsInfoMask( void *lpvBuff, int *lpiBuffSize )
{
	unsigned long ulMask = UI_CHARACTERISTICS | UI_PARAMETERS | UI_SETUP_PARAMETERS | UI_UPS_STATE;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUpsInfoMask
// Description		: 
int	SinlineXL_DoSetUpsInfoMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoGetUpsStateMask
// Description		: 
int	SinlineXL_DoGetUpsStateMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long	ulMask = US_POWERON | US_POWERFAIL | US_STANDBY | US_OVERLOAD | US_AVRUP |
		US_AVRLOWER | US_BATTERYDEPLETED | US_WATCH | US_SHORT | US_INTERNALERROR | US_BATTERYLOW |
		US_INVERTERFAILURE | US_TEMPERATURETOOHIGH | US_TEMPERATURETOOLOW | US_BADEXTERNALMODULES;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUpsStateMask
// Description		: 
int	SinlineXL_DoSetUpsStateMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoGetUpsState
// Description		: Return actual UPS state
int	SinlineXL_DoGetUpsState(void *lpvBuff, int *lpiBuffSize)
{
#undef CONVERT_BIT
#define CONVERT_BIT(src, sbit, dest, dbit) { if (src & sbit) dest |= dbit; else dest &= ~(dbit); }

	unsigned int	*lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	int				iSize = UPS_INF_COUNT;
	unsigned long	ulUpsState = 0;
	int				iRet;
	double			dBattVlt, dLoadOut, dLowBattery;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof(ulUpsState))
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = SinlineXL_DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS)
	{
		delete [] lpuiInfoTable;
		return iRet;
	}

	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0001, ulUpsState, US_BADEXTERNALMODULES );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0002, ulUpsState, US_TEMPERATURETOOLOW );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0004, ulUpsState, US_TEMPERATURETOOHIGH );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0008, ulUpsState, US_INVERTERFAILURE );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0010, ulUpsState, US_INTERNALERROR );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0020, ulUpsState, 0x0 );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0040, ulUpsState, 0x0 );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0080, ulUpsState, US_SHORT );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0100, ulUpsState, US_OVERLOAD );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0200, ulUpsState, US_BATTERYDEPLETED );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0400, ulUpsState, US_WATCH );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x0800, ulUpsState, US_AVRLOWER );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x1000, ulUpsState, US_AVRUP );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x2000, ulUpsState, US_STANDBY );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x4000, ulUpsState, US_POWERFAIL );
	CONVERT_BIT( lpuiInfoTable[ TRYB_PRACY ], 0x8000, ulUpsState, US_POWERON );

	/* Low battery signal is set if battery cap. is below or equal to value set by user
	 at configuration time, and by default is set to 10% */
	if ( ( lpuiInfoTable[ POJ_AKU ] <= sdcSinlinexl.uiBattCapToLB ) && 
		 ( ( ulUpsState & US_POWERFAIL ) == US_POWERFAIL ) ) {
		ulUpsState |= US_BATTERYLOW;
	} else {
		ulUpsState &= ~( US_BATTERYLOW );
	}
	
	memcpy( lpvBuff, &ulUpsState, *lpiBuffSize );

	delete [] lpuiInfoTable;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetUpsParamsMask
// Description		: 
int	SinlineXL_DoGetUpsParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulMask = UP_PST_UPPER | UP_PST_LOWER | UP_PST_AVRUP | UP_PST_AVRLOW |
		UP_FRQ_INPUT | UP_FRQ_OUTPUT | UP_VLT_INPUT	| UP_VLT_OUTPUT | UP_VLT_BATTERY | 
		UP_PRC_BATTERYCAPACITY | UP_PRC_POWERWEIGHT | UP_TMV_AUTONOMY | UP_TMP_INVERTER | 
		UP_TMP_CASING | UP_UID_FAMILY | UP_UID_MODEL | UP_OV_EXTMODULES;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUpsParamsMask
// Description		: 
int	SinlineXL_DoSetUpsParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoGetUpsParams
// Description		: 
int	SinlineXL_DoGetUpsParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	unsigned int *lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	unsigned int *lpuiCharTable = new unsigned int[UPS_CHARAKTER_COUNT];
	unsigned int *lpuiSpecialTable = new unsigned int[UPS_SPECIAL_COUNT];
	int iSize, iRet, i, iv[3], iv2[3];
	supsp sup;
	char szUpsName[UPS_MAX_MODELS][64] = { UPS_MODEL_700, UPS_MODEL_1000, UPS_MODEL_1500, 
		UPS_MODEL_2000, UPS_MODEL_2500, UPS_MODEL_3000
	};

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( supsp ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	if(((iRet=SinlineXL_DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &(iSize = UPS_INF_COUNT)))!=IOCTL_ERROR_SUCCESS) || 
		((iRet=SinlineXL_DoGetUPSStructures(EU_SETUP, lpuiSetupTable, &(iSize = UPS_SETUP_COUNT)))!=IOCTL_ERROR_SUCCESS) || 
		((iRet=SinlineXL_DoGetUPSStructures(EU_CHARACTERISTIC, lpuiCharTable, &(iSize = UPS_CHARAKTER_COUNT)))!=IOCTL_ERROR_SUCCESS) || 
		((iRet=SinlineXL_DoGetUPSStructures(EU_SPECIAL, lpuiSpecialTable, &(iSize = UPS_SPECIAL_COUNT)))!=IOCTL_ERROR_SUCCESS))
	{
		delete [] lpuiInfoTable;
		delete [] lpuiSetupTable;
		delete [] lpuiCharTable;
		delete [] lpuiSpecialTable;
		return iRet;
	}
	
	sup.ulMask = UP_PST_UPPER | UP_PST_LOWER | UP_PST_AVRUP	| UP_PST_AVRLOW | 
		UP_FRQ_INPUT | UP_FRQ_OUTPUT | UP_VLT_INPUT | UP_VLT_OUTPUT | UP_VLT_BATTERY | 
		UP_PRC_BATTERYCAPACITY | UP_PRC_POWERWEIGHT | UP_TMV_AUTONOMY | UP_TMP_INVERTER | 
		UP_TMP_CASING | UP_UID_FAMILY | UP_UID_VERSION | UP_UID_MODEL | UP_OV_EXTMODULES;
	
	i = iSinlineXL_UpsSeries = (lpuiSpecialTable[ ID_TYP_VHW ] >> 8) & 0xF;
	
	sprintf( sup.sz__uid_model, "%s %s", DRIVER_UPS_PREFIX, szUpsName[ i-1 ] );
	sprintf( sup.sz__uid_family, "%s", DRIVER_UPS_FAMILY );

	iSinlineXL_FirmRev = lpuiSpecialTable[ MAGIC_NUMBER ];
	
	iv[0] = ( iSinlineXL_FirmRev >> 12 ) & 0xF;
	iv[1] = ( iSinlineXL_FirmRev >> 8 ) & 0xF;
	iv[2] = ( iSinlineXL_FirmRev & 0xFF );
	sprintf( sup.sz__uid_version, "Firmware: %d.%d b%d", iv[0], iv[1], iv[2] );


	/* TODO
	if ((bSinlineXL_FirmUns_Pass==false) &&
		(iSinlineXL_FirmRev>FIRMWARE_LAST || iSinlineXL_FirmRev<FIRMWARE_FIRST))
	{
		bSinlineXL_FirmUns_Pass=true;
		iv[0] = ( FIRMWARE_LAST & 0xFF ) >> 4;
		iv[1] = ( FIRMWARE_LAST & 0x0F );
		iv2[0] = ( lpuiInfoTable[ UPS_FIRMWARE_VER ] & 0xFF ) >> 4;
		iv2[1] = ( lpuiInfoTable[ UPS_FIRMWARE_VER ] & 0x0F );
		// unsupported version of UPS firmware
		error_report(TXT_ERR_FIRMWARE_UNSUPPORTED, 
			sup.sz__uid_model, iv2[0], iv2[1], iv[0], iv[1]);

		delete [] lpuiInfoTable;
		return IOCTL_CRITICAL_ERROR;
	}
	*/

	sup.ui__frq_input = lpuiInfoTable[ F_WEJ ];
	sup.ui__frq_input_div = 10;
	sup.ui__frq_output = lpuiSetupTable[ F_WYJ ];
	sup.ui__frq_output_div = 10;

	sup.ui__load_output = (lpuiInfoTable[ OBCIAZENIE ] * lpuiCharTable[ P_WYJ_MAX ]) / 100;
	sup.ui__load_output_div = 1;
	sup.ui__ov_extmodules = lpuiInfoTable[ DOD_MOD ];
	sup.ui__ov_extmodules_div = 1;
	sup.ui__prc_batterycapacity = lpuiInfoTable[ POJ_AKU ];
	sup.ui__prc_batterycapacity_div = 1;
	sup.ui__prc_powerweight = lpuiInfoTable[ OBCIAZENIE ];
	sup.ui__prc_powerweight_div = 1;

	sup.ui__pst_avrlow = lpuiSetupTable[ V_DOLNY_AVR ];
	sup.ui__pst_avrup = lpuiSetupTable[ V_GORNY_AVR ];
	sup.ui__pst_avrlow_div = sup.ui__pst_avrup_div = 1;
	sup.ui__pst_lower = lpuiSetupTable[ V_DOLNY ];
	sup.ui__pst_upper = lpuiSetupTable[ V_GORNY ];
	sup.ui__pst_lower_div = sup.ui__pst_upper_div = 1;
	
	/* czulosc:
	 * 0 = mala = 0x00; 1 = srednia = 0x0F; 2 = duza = 0xF0;
	 */
	switch(lpuiSetupTable[ CZULOSC ])
	{
	case 0x00: sup.ui__sns_frequency = sup.ui__sns_voltage = 0; break;
	case 0x0F: sup.ui__sns_frequency = sup.ui__sns_voltage = 1; break;
	case 0xF0: sup.ui__sns_frequency = sup.ui__sns_voltage = 2; break;
	}
	sup.ui__sns_frequency_div = sup.ui__sns_voltage_div = 1;

	sup.ui__tmp_casing = lpuiInfoTable[ TEMPERATURA_OT ];
	sup.ui__tmp_casing_div = 1;
	sup.ui__tmp_inverter = lpuiInfoTable[ TEMPERATURA ];
	sup.ui__tmp_inverter_div = 1;

	/* czas autonomi w sek. */
	sup.ui__tmv_autonomy = lpuiInfoTable[ CZAS_PRACY ];
	sup.ui__tmv_autonomy_div = 1;

	sup.ui__vlt_battery = lpuiInfoTable[ V_AKU ];
	sup.ui__vlt_battery_div = 10;
	sup.ui__vlt_input = lpuiInfoTable[ V_WEJ ];
	sup.ui__vlt_input_div = 1;
	sup.ui__vlt_output = lpuiInfoTable[ V_WYJ ];
	sup.ui__vlt_output_div = 1;

	memcpy( lpvBuff, &sup, sizeof(supsp) );

	delete [] lpuiInfoTable;
	delete [] lpuiSetupTable;
	delete [] lpuiCharTable;
	delete [] lpuiSpecialTable;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetUpsSetupParamsMask
// Description		: 
int	SinlineXL_DoGetUpsSetupParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulMask = UP_SET_PST_UPPER | UP_SET_PST_LOWER | UP_SET_PST_AVRUP | 
		UP_SET_PST_AVRLOW | UP_SET_AAL_ON | UP_SET_TMR_POWERFAILTOSTANDBY | 
		UP_SET_FRQ_OUTPUT | UP_SET_SNS_VOLTAGE | UP_SET_SNS_FREQUENCY;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUpsSetupParamsMask
// Description		: 
int	SinlineXL_DoSetUpsSetupParamsMask(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoGetUpsSetupParams
// Description		: 
int	SinlineXL_DoGetUpsSetupParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	int iSize = UPS_SETUP_COUNT;
	int iRet;
	supssp susp;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof(unsigned int) * UPS_SETUP_COUNT)
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = SinlineXL_DoGetUPSStructures(EU_SETUP, lpuiSetupTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS) {
		delete [] lpuiSetupTable;
		return iRet;
	}

	susp.ulMask = UP_SET_PST_UPPER | UP_SET_PST_LOWER | UP_SET_PST_AVRUP | 
		UP_SET_PST_AVRLOW | UP_SET_AAL_ON | UP_SET_TMR_POWERFAILTOSTANDBY | 
		UP_SET_FRQ_OUTPUT | UP_SET_SNS_VOLTAGE | UP_SET_SNS_FREQUENCY;
	
	susp.ui__set_pst_upper = lpuiSetupTable[ V_GORNY ];
	susp.ui__set_pst_lower = lpuiSetupTable[ V_DOLNY ];
	susp.ui__set_pst_upper_div = susp.ui__set_pst_lower_div = 1;

	susp.ui__set_pst_avrlow = lpuiSetupTable[ V_DOLNY_AVR ];
	susp.ui__set_pst_avrup = lpuiSetupTable[ V_GORNY_AVR ];
	susp.ui__set_pst_avrlow_div = susp.ui__set_pst_avrup_div = 1;

	susp.ui__set_aal_on = (lpuiSetupTable[ KONTROLA_PRACY ] & 0x40) ? 1 : 0;
	susp.ui__set_tmr_powerfailtostandby = lpuiSetupTable[ OPOZNIENIE_STANDBY ];
	susp.ui__set_tmr_powerfailtostandby_div = 1;
	susp.ui__set_frq_output = lpuiSetupTable[ F_WYJ ];
	susp.ui__set_frq_output_div = 10;

	switch(lpuiSetupTable[ CZULOSC ])
	{
	case 0x00: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 0; break;
	case 0x0F: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 1; break;
	case 0xF0: susp.ui__set_sns_frequency = susp.ui__set_sns_voltage = 2; break;
	}
	susp.ui__set_sns_frequency_div = susp.ui__set_sns_voltage_div = 1;

	memcpy( lpvBuff, &susp, *lpiBuffSize );

	delete [] lpuiSetupTable;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUpsSetupParams
// Description		: 
int	SinlineXL_DoSetUpsSetupParams(void *lpvBuff, int *lpiBuffSize)
{
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoGetDriverInfo
// Description		: 
int	SinlineXL_DoGetDriverInfo(void *lpvBuff, int *lpiBuffSize)
{
	if (*lpiBuffSize != sizeof(sdrv_info))
		return IOCTL_ERROR_INVALIDARGUMENT;
	sprintf( (( lpsdrv_info )lpvBuff )->szName, "%s DRIVER", DRIVER_UPS_PREFIX );
	sprintf( (( lpsdrv_info )lpvBuff )->szFamily, "%s", DRIVER_UPS_FAMILY );
	((lpsdrv_info)lpvBuff)->eLink = ul_serial;
	((lpsdrv_info)lpvBuff)->uiVersionMajor = DRIVER_VERSION_MAJOR;
	((lpsdrv_info)lpvBuff)->uiVersionMinor = DRIVER_VERSION_MINOR;
	strcpy(((lpsdrv_info)lpvBuff)->szCfgFileName, DRIVER_CONFIG_FILE);
	strcpy(((lpsdrv_info)lpvBuff)->szBmpFileName, DRIVER_BITMAP_FILE);

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetExtendedError
// Description		: Get extended error information - return value of last error
int	SinlineXL_DoGetExtendedError(void *lpvBuff, int *lpiBuffSize)
{
	return iSinlinexl_ExtError;
}

// Function name	: SinlineXL_DoGetUpsCharacteristicMask
// Description		: 
int	SinlineXL_DoGetUpsCharacteristicMask(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulMask=UC_POWEROUT_MAX | UC_ADDMOD_MAXCAP	| UC_PST_LOWER_MIN |
		UC_PST_LOWER_MAX | UC_PST_UPPER_MIN	| UC_PST_UPPER_MAX | UC_PST_AVRUP_MIN |
		UC_PST_AVRDOWN_MAX | UC_INFREQ_MIN | UC_INFREQ_MAX | UC_OUTFREQ_MIN | 
		UC_OUTFREQ_MAX | UC_OUTVOLTAGE | UC_ACCUFULLCAPVOLTAGE;

	if ( *lpiBuffSize == sizeof( unsigned long ) )
		memcpy( lpvBuff, &ulMask, sizeof( unsigned long ) );
	else
		return IOCTL_ERROR_INVALIDARGUMENT;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetUpsCharacteristic
// Description		: 
int	SinlineXL_DoGetUpsCharacteristic(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiInfoTable = new unsigned int[UPS_CHARAKTER_COUNT];
	int iSize = UPS_CHARAKTER_COUNT;
	int iRet;
	supsch such;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( supsch ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	iRet = SinlineXL_DoGetUPSStructures(EU_CHARACTERISTIC, lpuiInfoTable, &iSize);
	if (iRet != IOCTL_ERROR_SUCCESS) {
		delete [] lpuiInfoTable;
		return iRet;
	}
	
	memset( &such, 0, sizeof(supsch) );

	such.ulMask = UC_POWEROUT_MAX | UC_ADDMOD_MAXCAP | UC_PST_LOWER_MIN |
		UC_PST_LOWER_MAX | UC_PST_UPPER_MIN	| UC_PST_UPPER_MAX | UC_PST_AVRUP_MIN |
		UC_PST_AVRDOWN_MAX | UC_INFREQ_MIN | UC_INFREQ_MAX | UC_OUTFREQ_MIN | 
		UC_OUTFREQ_MAX | UC_OUTVOLTAGE | UC_ACCUFULLCAPVOLTAGE;

	such.ui__addmod_maxcap = lpuiInfoTable[DOD_MOD_MAX];
	such.ui__addmod_maxcap_div = 1;
	such.ui__accufullcapvoltage = lpuiInfoTable[V_AKU_FULL];
	such.ui__accufullcapvoltage_div = 1;
	such.ui__infreq_max = such.ui__outfreq_max = lpuiInfoTable[F_MAX];
	such.ui__infreq_max_div = such.ui__outfreq_max_div = 1;
	such.ui__infreq_min = such.ui__outfreq_min = lpuiInfoTable[F_MIN];
	such.ui__infreq_min_div = such.ui__outfreq_min_div = 1;
	such.ui__outvoltage = lpuiInfoTable[V_WYJ_NOM];
	such.ui__outvoltage_div = 1;
	such.ui__powerout_max = lpuiInfoTable[P_WYJ_MAX];
	such.ui__powerout_max_div = 1;
	such.ui__pst_avrdown_max = lpuiInfoTable[V_AVRDOWN_MAX];
	such.ui__pst_avrdown_max_div = 1;
	such.ui__pst_avrup_min = lpuiInfoTable[V_AVRUP_MIN];
	such.ui__pst_avrup_min_div = 1;
	such.ui__pst_lower_max = lpuiInfoTable[V_DOLNY_MAX];
	such.ui__pst_lower_max_div = 1;
	such.ui__pst_lower_min = lpuiInfoTable[V_DOLNY_MIN];
	such.ui__pst_lower_min_div = 1;
	such.ui__pst_upper_max = lpuiInfoTable[V_GORNY_MAX];
	such.ui__pst_upper_max_div = 1;
	such.ui__pst_upper_min = lpuiInfoTable[V_GORNY_MIN];
	such.ui__pst_upper_min_div = 1;

	memcpy( lpvBuff, &such, *lpiBuffSize );
	delete [] lpuiInfoTable;

	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoTestUpsLink
// Description		: 
int	SinlineXL_DoTestUpsLink(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiInfoTable = new unsigned int[UPS_INF_COUNT];
	int iSize=UPS_INF_COUNT, iRet;
	
	iRet = SinlineXL_DoGetUPSStructures(EU_INFORMATIONS, lpuiInfoTable, &iSize);
	delete [] lpuiInfoTable;
	
	return iRet;
}

// Function name	: SinlineXL_DoGetUPSStructures
// Description		: Return specified structure from UPS
int SinlineXL_DoGetUPSStructures(eups_structs eType, void *lpvBuff, int *lpiBuffSize)
{
#undef COMMIOFAIL
#define COMMIOFAIL( v, en ) { if ( COMMFAIL( v ) ) {	\
	iSinlinexl_ExtError = en; return IOCTL_ERROR_COMM_LINKFAIL; } }

	unsigned char ucDataBuff[0xFF]={ 0 }, ucLength=0, ucCRC=0;
	int iindex;
	unsigned int uiDataBuff[0xFF]={ 0 };
	unsigned long ulCRC=0, ulCRC2=0;
	bool bInitialized=false;
	
	if (!commSinlinexl.isInitialized())
		return IOCTL_ERROR_NOTYETINITIALIZED;

	/* 
	 * Asking UPS
	 */
	for (int i = 0; i < 5; i++) {
		ucDataBuff[0]=0;
		commSinlinexl.flush(1,1);
		commSinlinexl.send(FRAME_INITCODE);
		usleep(250000);
		commSinlinexl.receive(&ucDataBuff[0]);

		if (ucDataBuff[0]==FRAME_INITCODE) {
			//printf("\n[%d]read->ok",eType);
			bInitialized = true;
			break;
		} else if (ucDataBuff[0]==FRAME_BUSY) {
			//printf("\n[%d]read->busy",eType);
			sleep(1);
			continue;
		}
		//printf("\n[%d]read->fail",eType);
		sleep(1);
	}
	if (!bInitialized) {
		iSinlinexl_ExtError=IOCTL_ERROR_COMM_INVALIDCODE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( commSinlinexl.send( FRAME_START ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucLength=3;
	COMMIOFAIL( commSinlinexl.send( ucLength ), IOCTL_ERROR_COMM_FAILTOSEND );
	COMMIOFAIL( commSinlinexl.send( FRAME_CMD_GET ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC+=FRAME_CMD_GET;
	COMMIOFAIL( commSinlinexl.send( eType ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC+=eType;
	ucCRC%=256;
	COMMIOFAIL( commSinlinexl.send( ucCRC ), IOCTL_ERROR_COMM_FAILTOSEND );
	/* 
	 * USP response
	 */
	ucDataBuff[0]=ucDataBuff[1]=ucDataBuff[2]=0;
	COMMIOFAIL( commSinlinexl.receive(&ucDataBuff[0]), IOCTL_ERROR_COMM_FAILTORECEIVE );
	if (ucDataBuff[0]!=FRAME_START) {
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_INVALIDFRAME;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}

	COMMIOFAIL( commSinlinexl.receive( &ucLength ), IOCTL_ERROR_COMM_FAILTORECEIVE );

	/* :: length = (length - crc_byte) / 2 */
	if ( ((ucLength - 1) / 2) > *lpiBuffSize ) {
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_INVALIDLENGTH;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( commSinlinexl.receive2b( uiDataBuff, (ucLength - 1) / 2, &ulCRC ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	COMMIOFAIL( commSinlinexl.receive( &ucCRC ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	
	ulCRC %= 256;
	if (ulCRC != ucCRC) {
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_INVALIDCRC;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}

	memcpy( lpvBuff, &uiDataBuff, *lpiBuffSize * sizeof( unsigned int ) );
	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetUPSStructures
// Description		: 
int SinlineXL_DoSetUPSStructures(eups_structs eType, void *lpvBuff, int *lpiBuffSize, int *lpiBuffErrPos )
{
#undef COMMIOFAIL
#define COMMIOFAIL( v, en ) { if ( COMMFAIL( v ) ) {	\
	iSinlinexl_ExtError = en; return IOCTL_ERROR_COMM_LINKFAIL; } }

	unsigned char ucDataBuff[0xFF]={ 0 }, ucLength=0, ucErrCode=0, ucCRC=0;
	unsigned int uiDataBuff[0xFF]={ 0 };
	unsigned long ulCRC=0;
	bool bInitialized=false;
	
	if ( !commSinlinexl.isInitialized() )
		return IOCTL_ERROR_NOTYETINITIALIZED;

	if ( !lpvBuff )
		return IOCTL_ERROR_INVALIDARGUMENT;
	memcpy( &uiDataBuff, lpvBuff, *lpiBuffSize * sizeof(unsigned int));
	/* 
	 * Asking UPS
	 */
	for (int i = 0; i < 5; i++) {
		ucDataBuff[0]=0;
		commSinlinexl.flush(1,1);
		commSinlinexl.send(FRAME_INITCODE);
		usleep(250000);
		commSinlinexl.receive(&ucDataBuff[0]);
		if (ucDataBuff[0]==FRAME_INITCODE) {
			//printf("\n[%d]write->ok",eType);
			bInitialized = true;
			break;
		} else if (ucDataBuff[0]==FRAME_BUSY) {
			//printf("\n[%d]write->busy",eType);
			sleep(1);
			continue;
		}
		//printf("\n[%d]write->fail",eType);
		sleep(1);
	}
	if (!bInitialized) {
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_INVALIDCODE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( commSinlinexl.send( FRAME_START ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucLength = 3 + (*lpiBuffSize * 2);
	ucCRC = 0;
	COMMIOFAIL( commSinlinexl.send( ucLength ), IOCTL_ERROR_COMM_FAILTOSEND );
	COMMIOFAIL( commSinlinexl.send( FRAME_CMD_SET ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += FRAME_CMD_SET;
	COMMIOFAIL( commSinlinexl.send( eType ), IOCTL_ERROR_COMM_FAILTOSEND );
	ucCRC += eType;
	COMMIOFAIL( commSinlinexl.send2b( (unsigned int *)lpvBuff, *lpiBuffSize ), IOCTL_ERROR_COMM_FAILTOSEND );

	for ( int j = 0; j < *lpiBuffSize; j++ )
		ucCRC += (LOBYTE(uiDataBuff[j]) + HIBYTE(uiDataBuff[j]));
	ucCRC %= 256;
	
	usleep(250000);
	commSinlinexl.flush(1,1);
	COMMIOFAIL( commSinlinexl.send( ucCRC ), IOCTL_ERROR_COMM_FAILTOSEND );
	/* 
	 * UPS response
	 */
	ucDataBuff[0]=ucDataBuff[1]=ucDataBuff[2]=0;
	COMMIOFAIL( commSinlinexl.receive( &ucDataBuff[0] ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	if (ucDataBuff[0] != FRAME_START) {
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_INVALIDFRAME;
		return IOCTL_ERROR_COMM_LINKFAIL;
	}
	COMMIOFAIL( commSinlinexl.receive( &ucErrCode ), IOCTL_ERROR_COMM_FAILTORECEIVE );
	switch( ucErrCode ) {
	case 0x05:	// Nieprawidlowa ilosc bajtow w ramce
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_BADFRAMELENGTH;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x0A:	// Nieznany typ rozkazu
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_UNKNOWNCOMMANDTYPE;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x15:	// Nieznany rozkaz
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_UNKNOWNCOMMAND;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x20:	// Blad CRC
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_BADCRC;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0x5F:	// Data integrity error
		COMMIOFAIL( commSinlinexl.receive( &ucErrCode ), IOCTL_ERROR_COMM_FAILTORECEIVE );
		if ( lpiBuffErrPos != NULL )
			*lpiBuffErrPos = ucErrCode;
		iSinlinexl_ExtError = IOCTL_ERROR_COMM_DATAINTEGRITY;
		return IOCTL_ERROR_COMM_LINKFAIL;
	case 0xFF:	// Success = no error
		break;
	}

	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetConfigParamsCount
// Description		: 
int	SinlineXL_DoGetConfigParamsCount(void *lpvBuff, int *lpiBuffSize)
{
	unsigned long ulCount = INT_MAX_SETUPITEMS;

	if ( lpiBuffSize != NULL )
		if ( *lpiBuffSize < sizeof( unsigned long ) )
			return IOCTL_ERROR_INVALIDARGUMENT;

	memcpy( lpvBuff, &ulCount, sizeof( ulCount ) );

	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetConfigParams
// Description		: 
int	SinlineXL_DoGetConfigParams(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiSetupTable = new unsigned int[UPS_SETUP_COUNT];
	unsigned int *lpuiCharTable = new unsigned int[UPS_CHARAKTER_COUNT];
	int icnt;
	scfg_value scfgvaldef[ INT_MAX_SETUPITEMS ];
	char szStr[ MAX_PATHBUFF ];
	unsigned long ulSize;

	if (lpiBuffSize != NULL)
		if (*lpiBuffSize < sizeof( scfgvaldef ))
			return IOCTL_ERROR_INVALIDARGUMENT;

	memcpy( lpuiSetupTable, &sdcSinlinexl.uiSetupTable, sizeof(sdcSinlinexl.uiSetupTable) );
	memcpy( lpuiCharTable, &sdcSinlinexl.uiCharacterTable, sizeof(sdcSinlinexl.uiCharacterTable) );

	/* Port komunikacyjny */
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_SERIALCOMM ].szName, TXT_CFG_COMMUNICATIONPORT);
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].value.iValue = (int)sdcSinlinexl.iSerialPort-1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].range.lMin = 0;
	
	for (icnt = 0; icnt < 32; icnt++) {
		sprintf(szStr, "/dev/ttyS%d", icnt+1);
		strcpy(scfgvaldef[ INT_UPSCFG_SERIALCOMM ].list[icnt].szName, szStr);
		scfgvaldef[ INT_UPSCFG_SERIALCOMM ].list[icnt].iValue = atoi((const char *)(szStr + 3) ) - 1;
		memset(szStr, 0, sizeof(szStr));
	}
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].range.lMax = icnt-1;
	scfgvaldef[ INT_UPSCFG_SERIALCOMM ].iListItems = icnt;

	/* KONTROLA_PRACY:buzer */
	scfgvaldef[ INT_UPSCFG_BUZZER ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].szName, TXT_CFG_SOUNDALERT);
	scfgvaldef[ INT_UPSCFG_BUZZER ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_BUZZER ].value.iValue = (int)
		(flag_check(sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ], FLAG_KONTROLA_PRACY_BUZZER) ? 1 : 0);
	scfgvaldef[ INT_UPSCFG_BUZZER ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_BUZZER ].range.lMax = 1;
	scfgvaldef[ INT_UPSCFG_BUZZER ].iListItems = 2;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].list[0].szName, TXT_CFG_DISABLED);
	scfgvaldef[ INT_UPSCFG_BUZZER ].list[0].iValue = 0;
	strcpy(scfgvaldef[ INT_UPSCFG_BUZZER ].list[1].szName, TXT_CFG_ENABLED);
	scfgvaldef[ INT_UPSCFG_BUZZER ].list[1].iValue = 1;

	/* F_WYJ */
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].szName, TXT_CFG_OUTPUTFREQ);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider = 10;
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].value.iValue = (int)(lpuiSetupTable[ F_WYJ ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].range.lMin = (long)(lpuiCharTable[ F_MIN ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].range.lMax = (long)(lpuiCharTable[ F_MAX ] / scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider);
	scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].iListItems = 0;

	/* CZULOSC */
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].szName, TXT_CFG_SENSITIVITY);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue = lpuiSetupTable[ CZULOSC ];
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].range.lMin = 0x00;
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].range.lMax = 0xF0;
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].iListItems = 3;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[0].szName, TXT_CFG_SENS_LOW);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[0].iValue = 0x00;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[1].szName, TXT_CFG_SENS_AVERAGE);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[1].iValue = 0x0F;
	strcpy(scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[2].szName, TXT_CFG_SENS_HIGH);
	scfgvaldef[ INT_UPSCFG_SENSITIVITY ].list[2].iValue = 0xF0;

	/* V_DOLNY */
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_DOLNY ].szName, TXT_CFG_POWERSTATELOWER);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].value.iValue = (int)(lpuiSetupTable[ V_DOLNY ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].range.lMin = (long)(lpuiCharTable[ V_DOLNY_MIN ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].range.lMax = (long)(lpuiCharTable[ V_DOLNY_MAX ] / scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY ].iListItems = 0;
	
	/* V_GORNY */
	scfgvaldef[ INT_UPSCFG_V_GORNY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_GORNY ].szName, TXT_CFG_POWERSTATEUPPER);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_GORNY ].value.iValue = (int)(lpuiSetupTable[ V_GORNY ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].range.lMin = (long)(lpuiCharTable[ V_GORNY_MIN ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].range.lMax = (long)(lpuiCharTable[ V_GORNY_MAX ] / scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY ].iListItems = 0;

	/* V_DOLNY_AVR */
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].szName, TXT_CFG_AVR_LOWER);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].value.iValue = (int)
		(lpuiSetupTable[ V_DOLNY_AVR ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].range.lMin = (long)
		(lpuiSetupTable[ V_DOLNY ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].range.lMax = (long)
		(lpuiCharTable[ V_AVRDOWN_MAX ] / scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].iListItems = 0;

	/* V_GORNY_AVR */
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].szName, TXT_CFG_AVR_UPPER);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].value.iValue = (int)
		(lpuiSetupTable[ V_GORNY_AVR ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].range.lMin = (long)
		(lpuiCharTable[ V_AVRUP_MIN ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].range.lMax = (long)
		(lpuiSetupTable[ V_GORNY ] / scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].iListItems = 0;

	/* OPOZNIENIE_STANDBY */
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].szName, TXT_CFG_STANDBYTIMEOUT);
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue = (int)
		(lpuiSetupTable[ OPOZNIENIE_STANDBY ] / scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider);
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].range.lMax = 32767;
	scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].iListItems = 0;
	
	/* KONTROLA_PRACY:shutdown */
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].eType = VT_INTLIST;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].szName, TXT_CFG_UPSONOFF);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].value.iValue = 
		(int)(flag_check(lpuiSetupTable[KONTROLA_PRACY], FLAG_KONTROLA_PRACY_SHUTDOWN) ? 1 : 0);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].range.lMin = 0;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].range.lMax = 1;
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].iListItems = 2;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[0].szName, TXT_CFG_DISABLED);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[0].iValue = 0;
	strcpy(scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[1].szName, TXT_CFG_ENABLED);
	scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].list[1].iValue = 1;

	/* LOW_BATTERY TRESHOLD */
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].eType = VT_INTEGER;
	strcpy(scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].szName, TXT_CFG_LOWBATTERYTRANSFERTRESHOLD);
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].dDivider = 1;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].value.iValue = (int)( sdcSinlinexl.uiBattCapToLB );
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].range.lMin = 1;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].range.lMax = 100;
	scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].iListItems = 0;
	
	memcpy( lpvBuff, scfgvaldef, *lpiBuffSize );

	delete [] lpuiSetupTable;
	delete [] lpuiCharTable;

	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetConfigParams
// Description		: Apply configuration from external program or just using parametrized interface
int	SinlineXL_DoSetConfigParams(void *lpvBuff, int *lpiBuffSize)
{
	int iSize, iRet;
	unsigned long ulSize;
	scfg_value scfgvaldef[ INT_MAX_SETUPITEMS ];

	if ( *lpiBuffSize != (sizeof(scfg_value) * INT_MAX_SETUPITEMS) )
		return IOCTL_ERROR_INVALIDARGUMENT;
	else
		memcpy( &scfgvaldef, lpvBuff, *lpiBuffSize );

	if (commSinlinexl.isInitialized()) {
		iSize = UPS_SETUP_COUNT;
		iRet = SinlineXL_DoGetUPSStructures(EU_SETUP, &sdcSinlinexl.uiSetupTable, &iSize);
		if (iRet != IOCTL_ERROR_SUCCESS) {
			return iRet;
		}
	} else {
		return IOCTL_ERROR_NOTYETINITIALIZED;
	}

	/* Port komunikacyjny */
	sdcSinlinexl.iSerialPort = scfgvaldef[ INT_UPSCFG_SERIALCOMM ].value.iValue + 1;
	sprintf(sdcSinlinexl.szSerialPort, "/dev/ttyS%d", scfgvaldef[ INT_UPSCFG_SERIALCOMM ].value.iValue + 1);
	
	/* KONTROLA_PRACY:buzer */
	if (scfgvaldef[ INT_UPSCFG_BUZZER ].value.iValue == 1)
		sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ] |= FLAG_KONTROLA_PRACY_BUZZER;
	else
		sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ] &= ~(FLAG_KONTROLA_PRACY_BUZZER);
	/* KONTROLA_PRACY:shutdown */
	if (scfgvaldef[ INT_UPSCFG_UPSSHUTDOWN ].value.iValue == 1)
		sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ] |= FLAG_KONTROLA_PRACY_SHUTDOWN;
	else
		sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ] &= ~(FLAG_KONTROLA_PRACY_SHUTDOWN);
	/* F_WYJ */
	sdcSinlinexl.uiSetupTable[F_WYJ] = (int)( scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_OUTPUTFREQ ].dDivider );
	/* CZULOSC */
	sdcSinlinexl.uiSetupTable[ CZULOSC ] = scfgvaldef[ INT_UPSCFG_SENSITIVITY ].value.iValue;
	/* V_DOLNY */
	sdcSinlinexl.uiSetupTable[ V_DOLNY ] = (int)(scfgvaldef[ INT_UPSCFG_V_DOLNY ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_DOLNY ].dDivider);
	/* V_GORNY */
	sdcSinlinexl.uiSetupTable[ V_GORNY ] = (int)(scfgvaldef[ INT_UPSCFG_V_GORNY ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_GORNY ].dDivider);
	/* V_DOLNY_AVR */
	sdcSinlinexl.uiSetupTable[ V_DOLNY_AVR ] = (int)(scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_DOLNY_AVR ].dDivider);
	/* V_GORNY_AVR */
	sdcSinlinexl.uiSetupTable[ V_GORNY_AVR ] = (int)(scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].value.iValue * 
		scfgvaldef[ INT_UPSCFG_V_GORNY_AVR ].dDivider);
	/* OPOZNIENIE_STANDBY */
	if ((int)(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue) < 60) {
		console_report( TXT_INF_STANDBYTIMETOOSHORT );
	}
	sdcSinlinexl.uiSetupTable[ OPOZNIENIE_STANDBY ] = (int)(scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].value.iValue *
		scfgvaldef[ INT_UPSCFG_STANDBYDELAY ].dDivider);
	/* LOW BATTERY */
	sdcSinlinexl.uiBattCapToLB = ( unsigned int )(scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].value.iValue *
		scfgvaldef[ INT_UPSCFG_LOWBATTERYTRSH ].dDivider);

	if (commSinlinexl.isInitialized()) {
		iSize=UPS_SETUP_COUNT;
		iRet=SinlineXL_DoSetUPSStructures(EU_SETUP, sdcSinlinexl.uiSetupTable, &iSize, NULL);
		if (iRet!=IOCTL_ERROR_SUCCESS)
			return iRet;
	}
	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoGetConfigParam
// Description		: 
int	SinlineXL_DoGetConfigParam(void *lpvBuff, int *lpiBuffSize)
{
	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoSetConfigParam
// Description		: 
int	SinlineXL_DoSetConfigParam(void *lpvBuff, int *lpiBuffSize)
{
	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_ReadConfig
// Description		: Read configuration from file
int	SinlineXL_ReadConfig()
{
	char *fp;
	fp = get_config_filepath(DRIVER_CONFIG_FILE);
	if (fp==NULL) {
		return IOCTL_ERROR;
	}
	CConf *pCfgDev = new CConf;
	if (pCfgDev->init(fp)!=CONF_SUCCESS) {
		free(fp);
		delete pCfgDev;
		return IOCTL_ERROR_CONFIG_READFAIL;
	} else {
		free(fp);
		pCfgDev->parse_config();
	}
	
	char szBuf[128] = "", *s;
	strcpy(sdcSinlinexl.szSerialPort, ((s=pCfgDev->getcfgitemvalue("commport"))=="")?"/dev/ttyS0":s);
	
	bool bAudibleAlarm=(bool)atoi(((s=pCfgDev->getcfgitemvalue("audible_alarm"))=="")?"1":s);
	if (bAudibleAlarm)
		flag_set( (unsigned long *)&sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ], FLAG_KONTROLA_PRACY_BUZZER );
	else
		flag_clear( (unsigned long *)&sdcSinlinexl.uiSetupTable[ KONTROLA_PRACY ], FLAG_KONTROLA_PRACY_BUZZER );
	/* F_WYJ */
	sdcSinlinexl.uiSetupTable[ F_WYJ ]=(int)(atoi(((s=pCfgDev->getcfgitemvalue("output_frequency_hz"))=="")?"50":s)*10);
	
	/* CZULOSC */
	s=pCfgDev->getcfgitemvalue("input_sensitivity");
	if (!strcasecmp(s, "low"))
		sdcSinlinexl.uiSetupTable[ CZULOSC ]=0x00;
	else if (!strcasecmp(s, "average"))
		sdcSinlinexl.uiSetupTable[ CZULOSC ]=0x0F;
	else if (!strcasecmp(s, "high"))
		sdcSinlinexl.uiSetupTable[ CZULOSC ]=0xF0;
	else
		sdcSinlinexl.uiSetupTable[ CZULOSC ]=0x0F;	// average is set by default if nothing else is set
	
	/* V_DOLNY */
	sdcSinlinexl.uiSetupTable[ V_DOLNY ]=(int)atoi(((s=pCfgDev->getcfgitemvalue("transfer_treshold_lower"))=="")?"170":s);
	/* V_GORNY */
	sdcSinlinexl.uiSetupTable[ V_GORNY ]=(int)atoi(((s=pCfgDev->getcfgitemvalue("transfer_treshold_upper"))=="")?"260":s);
	/* V_DOLNY_AVR */
	sdcSinlinexl.uiSetupTable[ V_DOLNY_AVR ]=(int)atoi(((s=pCfgDev->getcfgitemvalue("transfer_treshold_avr_lower"))=="")?"200":s);
	/* V_GORNY_AVR */
	sdcSinlinexl.uiSetupTable[ V_GORNY_AVR ]=(int)atoi(((s=pCfgDev->getcfgitemvalue("transfer_treshold_avr_upper"))=="")?"250":s);
	/* OPOZNIENIE_STANDBY */
	sdcSinlinexl.uiSetupTable[ OPOZNIENIE_STANDBY ]=(int)atoi(((s=pCfgDev->getcfgitemvalue("powerfail_to_standby_timeout"))=="")?"90":s);
	/* LOW BATTERY */
	sdcSinlinexl.uiBattCapToLB=(int)atoi(((s=pCfgDev->getcfgitemvalue("low_battery_treshold"))=="")?"10":s);
	if (sdcSinlinexl.uiBattCapToLB>90)
		sdcSinlinexl.uiBattCapToLB=90;
	if (sdcSinlinexl.uiBattCapToLB<1)
		sdcSinlinexl.uiBattCapToLB=1;
	
	delete pCfgDev;
	
	return IOCTL_ERROR_SUCCESS;
}

// Function name	: SinlineXL_DoUpdateConfig
// Description		: 
int	SinlineXL_DoUpdateConfig(void *lpvBuff, int *lpiBuffSize)
{
	iSinlinexl_ExtError = 0;
	
	if (SinlineXL_ReadConfig() != IOCTL_ERROR_SUCCESS)
		return IOCTL_ERROR_CONFIG_READFAIL;
	
	/* opoznienie standby */
	if ((int)sdcSinlinexl.uiSetupTable[ OPOZNIENIE_STANDBY ] < 60) {
		console_report( TXT_INF_STANDBYTIMETOOSHORT );
	}
	int iSize=UPS_SETUP_COUNT;
	return SinlineXL_DoSetUPSStructures(EU_SETUP, sdcSinlinexl.uiSetupTable, &iSize, NULL);
}

// Function name	: SinlineXL_DoGetDriverMode
// Description		: 
// Return type		: int
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int	SinlineXL_DoGetDriverMode(void *lpvBuff, int *lpiBuffSize)
{
	iSinlinexl_ExtError = 0;
	return IOCTL_ERROR_CMD_NOTSUPPORTED;
}

// Function name	: SinlineXL_DoUpsShutdown
// Description		: 
// Return type		: int 
// Argument         : void *lpvBuff
// Argument         : int *lpiBuffSize
int SinlineXL_DoUpsShutdown(void *lpvBuff, int *lpiBuffSize)
{
	unsigned int *lpuiSetupTable = new unsigned int[ UPS_SETUP_COUNT ];
	int iRet, iSize = UPS_SETUP_COUNT;

	iRet = SinlineXL_DoGetUPSStructures( EU_SETUP, lpuiSetupTable, &iSize );
	if (iRet != IOCTL_ERROR_SUCCESS) {
		delete [] lpuiSetupTable;
		return iRet;
	}
	
	/* KONTROLA_PRACY:shutdown */
	flag_set((unsigned long *)&lpuiSetupTable[ KONTROLA_PRACY ], 0x08);

	iSize = UPS_SETUP_COUNT;
	iRet = SinlineXL_DoSetUPSStructures( EU_SETUP, lpuiSetupTable, &iSize, NULL );
	if ( iRet != IOCTL_ERROR_SUCCESS )
		return iRet;

	delete [] lpuiSetupTable;
	iSinlinexl_ExtError = 0;
	
	return IOCTL_ERROR_SUCCESS;
}

